<?
  // VStarBlogEngine - functions.php
  // (C) 2008-2012 Vladislav Staroselskiy (inet@vladstar.com)

  function BlogTitles($limit=BLOG_TITLES_LIMIT,$style=BLOG_CSS_STYLE,$preview=false,$page=false,$month=false,$year=false,$tag=false) {
    global $blog,$blog1,$userid,$username,$useremail,$userstatus;
    $ret="";

    $select="SELECT DISTINCT ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_ID." AS ID, 
              DATE_FORMAT(".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_DATETIME.",'".BLOG_DATE_FORMAT."') AS Date, 
              DATE_FORMAT(".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_DATETIME.",'".BLOG_TIME_FORMAT."') AS Time, 
              ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_TITLE." AS Title, 
              ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_POST_STATUS." AS PostStatus,
              ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_COMMENT_STATUS." AS CommentStatus,
              ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_SUBSCRIBE." AS Subscribe,
              ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_LJ_URL." AS LJ_URL,
              ".BLOG_USERS_TABLE.".".BLOG_USERS_TABLE_ID." AS Post_User_ID,
              ".BLOG_USERS_TABLE.".".BLOG_USERS_TABLE_NAME." AS User
              ".($preview?", ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_CONTENT." AS Content":"");
    $from  = "FROM ".BLOG_POSTS_TABLE.", ".BLOG_USERS_TABLE;
    $where = "WHERE ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_USER_ID."=".BLOG_USERS_TABLE.".".BLOG_USERS_TABLE_ID.
             ($userstatus!=BLOG_USERS_TABLE_USER_STATUS_ADMIN?" AND (".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_POST_STATUS."='".BLOG_POSTS_TABLE_POST_STATUS_PUBLIC."'".($userid?" OR ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_USER_ID."='".$userid."' OR ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_POST_STATUS."='".BLOG_POSTS_TABLE_POST_STATUS_FRIENDS."'":"").")":"");
    $order = "ORDER BY ".BLOG_POSTS_TABLE_DATETIME." DESC";
    $sqllimit = "LIMIT ".($page?$page*$limit.",":"").$limit;

    $title="";
    if ($tag) {
      $from .=", ".BLOG_TAGS2POSTS_TABLE.", ".BLOG_TAGS_TABLE;
      $where.=" AND ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_ID."=".BLOG_TAGS2POSTS_TABLE.".".BLOG_TAGS2POSTS_TABLE_POST_ID."
            AND ".BLOG_TAGS_TABLE.".".BLOG_TAGS_TABLE_ID."=".BLOG_TAGS2POSTS_TABLE.".".BLOG_TAGS2POSTS_TABLE_TAG_ID."
            AND ".BLOG_TAGS_TABLE.".".BLOG_TAGS_TABLE_NAME."='".addslashes($tag)."'";
      $title=BLOG_BY_TAG." ".$tag;
    } elseif ($month || $year) {
      $where.=" AND ".BLOG_COMMENTS_TABLE_DATETIME." LIKE '%".$year."-".($month?$month."-":"")."%'";
      $title=BLOG_BY_DATE." ".$month."/".$year;
    }
    $totalrecords=get_value("SELECT COUNT(*) ".$from." ".$where);

    $query=$select." ".$from." ".$where." ".$order." ".$sqllimit;
    $blog->query($query);
    if ($blog->num_rows()) {
      $ret.="<table class=\"".$style."\">\n";
      $ret.="<tr class=\"".$style."_header\"><td colspan=3 class=\"".$style."_header\">".(($page+1)*$limit<$totalrecords?"<a class=\"".$style."_header\" title=\"".BLOG_OLDER_DESCRIPTION."\" href=\"".params(false, false, $tag, $page+1, $year, $month)."\">".BLOG_OLDER."</a>":"").(($page+1)*$limit<$totalrecords||$page?" <small class=\"".$style."\">(".($page*$limit+1)."-".($limit*($page+1)<$totalrecords?$limit*($page+1):$totalrecords)." ".BLOG_OF." ".$totalrecords.")</small> ":"").($page?"<a class=\"".$style."_header\" title=\"".BLOG_NEWER_DESCRIPTION."\" href=\"".params(false, false, $tag, ($page-1), $year, $month)."\">".BLOG_NEWER."</a>":"")."<hr></td></tr>\n";
      while($blog->next_record()) {
        if ($preview) {
          $ret.=ShowPost($style,true,$blog->f("ID"),$blog->f("Post_User_ID"),stripslashes($blog->f("User")),$blog->f("Date"),$blog->f("Time"),stripslashes($blog->f("Title")),nl2br(stripslashes($blog->f("Content"))),stripslashes($blog->f("CommentStatus")),stripslashes($blog->f("PostStatus")),stripslashes($blog->f("Subscribe")),stripslashes($blog->f("LJ_URL")));
        } else {
          $ret.="<tr class=\"".$style."\" title=\"".BLOG_POSTED_BY." ".stripslashes($blog->f("User"))."\"><th class=\"".$style."\">".$blog->f("Date")."</th><td class=\"".$style."\"><a class=\"".$style."\" href=\"".params($blog->f("ID"))."\">".stripslashes($blog->f("Title"))."</a>".($blog->f("PostStatus")==BLOG_POSTS_TABLE_POST_STATUS_FRIENDS?" ".BLOG_POSTS_TABLE_POST_STATUS_FRIENDS_SIGN:($blog->f("PostStatus")==BLOG_POSTS_TABLE_POST_STATUS_PRIVATE?" ".BLOG_POSTS_TABLE_POST_STATUS_PRIVATE_SIGN:""))."</td></tr>\n";
          $title="";
        }
      }
      $ret.="\n<tr class=\"".$style."_header\"><td colspan=3 class=\"".$style."_header\">".(($page+1)*$limit<$totalrecords?"<a class=\"".$style."_header\" title=\"".BLOG_OLDER_DESCRIPTION."\" href=\"".params(false, false, $tag, $page+1, $year, $month)."\">".BLOG_OLDER."</a>":"").(($page+1)*$limit<$totalrecords||$page?" <small class=\"".$style."\">(".($page*$limit+1)."-".($limit*($page+1)<$totalrecords?$limit*($page+1):$totalrecords)." ".BLOG_OF." ".$totalrecords.")</small> ":"").($page?"<a class=\"".$style."_header\" title=\"".BLOG_NEWER_DESCRIPTION."\" href=\"".params(false, false, $tag, ($page-1), $year, $month)."\">".BLOG_NEWER."</a>":"")."</td></tr>\n";
      $ret.="</table>\n";
    }
    return array($title,$ret);
  }

  function BlogItem($post,$thread,$limit=BLOG_COMMENTS_LIMIT,$style=BLOG_CSS_STYLE,$page=0) {
    global $blog,$userid,$username,$useremail,$userstatus,$bannedip;
    $ret="";

    $query="SELECT DISTINCT ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_ID.", 
              ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_DATETIME." AS DateTime,
              DATE_FORMAT(".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_DATETIME.",'".BLOG_DATE_FORMAT."') AS Date, 
              DATE_FORMAT(".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_DATETIME.",'".BLOG_TIME_FORMAT."') AS Time, 
              ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_TITLE." AS Title, 
              ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_POST_STATUS." AS PostStatus,
              ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_COMMENT_STATUS." AS CommentStatus,
              ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_SUBSCRIBE." AS Subscribe,
              ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_LJ_URL." AS LJ_URL,
              ".BLOG_USERS_TABLE.".".BLOG_USERS_TABLE_ID." AS Post_User_ID, 
              ".BLOG_USERS_TABLE.".".BLOG_USERS_TABLE_NAME." AS User, 
              ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_CONTENT." AS Content
              FROM ".BLOG_POSTS_TABLE.", ".BLOG_USERS_TABLE."
              WHERE ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_USER_ID."=".BLOG_USERS_TABLE.".".BLOG_USERS_TABLE_ID."
              AND ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_ID."='".$post."'
              ".($userstatus!=BLOG_USERS_TABLE_USER_STATUS_ADMIN?" AND (".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_POST_STATUS."='".BLOG_POSTS_TABLE_POST_STATUS_PUBLIC."'".($userid?" OR ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_USER_ID."='".$userid."' OR ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_POST_STATUS."='".BLOG_POSTS_TABLE_POST_STATUS_FRIENDS."'":"").")":"");
    $blog->query($query);
    if ($blog->num_rows()) {
      $blog->next_record();
      $prev_rec=get_value("SELECT ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_ID." FROM ".BLOG_POSTS_TABLE." WHERE ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_DATETIME."<'".$blog->f("DateTime")."'".(! $userid?" AND ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_POST_STATUS."='".BLOG_POSTS_TABLE_POST_STATUS_PUBLIC."'":"")." ORDER BY ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_DATETIME." DESC LIMIT 1");
      $next_rec=get_value("SELECT ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_ID." FROM ".BLOG_POSTS_TABLE." WHERE ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_DATETIME.">'".$blog->f("DateTime")."'".(! $userid?" AND ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_POST_STATUS."='".BLOG_POSTS_TABLE_POST_STATUS_PUBLIC."'":"")." ORDER BY ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_DATETIME." LIMIT 1");
      $ret.="<table class=\"".$style."\">\n";
      $ret.="<tr class=\"".$style."_header\"><td colspan=3 class=\"".$style."_header\">".($prev_rec?"<a class=\"".$style."_header\" title=\"".BLOG_OLDER_DESCRIPTION."\" href=\"".params($prev_rec)."\">".BLOG_OLDER."</a>":"").($prev_rec&&$next_rec?" | ":"").($next_rec?"<a class=\"".$style."_header\" title=\"".BLOG_NEWER_DESCRIPTION."\" href=\"".params($next_rec)."\">".BLOG_NEWER."</a>":"")."<hr></td></tr>\n";
      $ret.=ShowPost($style,false,$post,$blog->f("Post_User_ID"),stripslashes($blog->f("User")),$blog->f("Date"),$blog->f("Time"),stripslashes($blog->f("Title")),nl2br(stripslashes($blog->f("Content"))),stripslashes($blog->f("CommentStatus")),stripslashes($blog->f("PostStatus")),stripslashes($blog->f("Subscribe")),stripslashes($blog->f("LJ_URL")));
      $ret.="<tr class=\"".$style."_header\"><td colspan=3 class=\"".$style."_header\">".BLOG_COMMENTS.": ".($blog->f("CommentStatus")==BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN && ! $bannedip?" (<a class=\"".$style."\" href=\"".params($post)."#reply\">".BLOG_POST_COMMENT."</a>)":"")."</td></tr>\n";
      $ret.=BlogComments($post,$thread,$limit,$style."_comments",$page,$blog->f("CommentStatus"),$blog->f("Post_User_ID"));
      $ret.="</table>\n";
      $title=stripslashes($blog->f("Title"));
    } else {
      $title=$ret=BLOG_MESSAGE_POST_NOT_FOUND;
    }
    return array($title,$ret);
  }

  function ShowPost($style,$preview,$id,$post_user_id,$user,$date,$time,$title,$content,$status,$poststatus,$subscribe,$ljurl) {
    global $blog1,$userid,$username,$useremail,$userstatus,$userljname,$userljpass,$userljjournal,$bannedip;
    $ret="";
    $ret.="\n<tr class=\"".$style."\"><td class=\"".$style."_side\">".$date." ".$time."</td><td class=\"".$style."\"><h2 class=\"".$style."\"><a class=\"".$style."\" href=\"".params($id)."\">".$title."</a>".($poststatus==BLOG_POSTS_TABLE_POST_STATUS_FRIENDS?" <span title=\"".BLOG_POSTS_TABLE_POST_STATUS_FRIENDS_NAME."\">".BLOG_POSTS_TABLE_POST_STATUS_FRIENDS_SIGN."</span>":($poststatus==BLOG_POSTS_TABLE_POST_STATUS_PRIVATE?" <span title=\"".BLOG_POSTS_TABLE_POST_STATUS_PRIVATE_NAME."\">".BLOG_POSTS_TABLE_POST_STATUS_PRIVATE_SIGN."</span>":""))."</h2></td><td class=\"".$style."_side\">".BLOG_POSTED_BY." ".$user."</td></tr>\n";
    $ret.="<tr class=\"".$style."\"><td colspan=3 class=\"".$style."\">\n";
    $ret.="<p class=\"".$style."\">".($preview&&strpos($content,"<!--more-->")?substr($content,0,strpos($content,"<!--more-->"))."<br><a class=\"".$style."\" href=\"".params($id)."\">".BLOG_MORE."</a>":$content)."</p>\n";
    $ret.="<p class=\"".$style."\">".BLOG_COMMENTS.": ";
    if ($temp=get_value("SELECT COUNT(*) FROM ".BLOG_COMMENTS_TABLE." WHERE ".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_POST_ID."='".$id."'".(!$userid?" AND ".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_STATUS."!='".BLOG_COMMENTS_TABLE_STATUS_SPAM."'":""))) {
      $ret.=$temp;
    } else {
      $ret.=BLOG_NONE;
    }
    $ret.=($status==BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN && ! $bannedip?" (<a class=\"".$style."\" href=\"".params($id)."#reply\">".BLOG_POST_REPLY."</a>) ":"")."&nbsp;&nbsp;&nbsp;".BLOG_TAGS.": ";
    if ($tags=GetTags($id)) {
      foreach($tags as $key=>$tag) {
        if ($key!=0) $ret.=" | ";
        $ret.="<a class=\"tags\" href=\"".params(false, false, urlencode($tag))."\">".$tag."</a>";
      }
    } else {
      $ret.=BLOG_NONE;
    }
    $ret.=($ljurl?"&nbsp;&nbsp;&nbsp;".BLOG_LJ.": <a href=\"".$ljurl."\" target=\"lj\">".BLOG_LJ_LINK."</a>":"")."</p>\n";
    if ($userid && (($userid==$post_user_id && $userstatus==BLOG_USERS_TABLE_USER_STATUS_REGULAR) || $userstatus==BLOG_USERS_TABLE_USER_STATUS_ADMIN)) $ret.="<small class=\"".$style."\"> <a href=\"?table=".BLOG_POSTS_TABLE."&id=".$id."&action=edit\">".BLOG_ADMIN_POST_EDIT."</a>&nbsp;&nbsp;&nbsp;<a href=\"?table=".BLOG_POSTS_TABLE."&id=".$id."&action=delete\">".BLOG_ADMIN_POST_DELETE."</a>&nbsp;&nbsp;&nbsp;<a href=\"?table=".BLOG_POSTS_TABLE."&id=".$id."&action=".($status==BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN?"close":"open")."\">".($status==BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN?BLOG_ADMIN_POST_CLOSE_COMMENTS:BLOG_ADMIN_POST_OPEN_COMMENTS)."</a>&nbsp;&nbsp;&nbsp;<a href=\"?table=".BLOG_POSTS_TABLE."&id=".$id."&action=".($subscribe==BLOG_POSTS_TABLE_SUBSCRIBE_YES?"unsubscribe":"subscribe")."\">".($subscribe==BLOG_POSTS_TABLE_SUBSCRIBE_YES?BLOG_ADMIN_POST_UNSUBSCRIBE_COMMENTS:BLOG_ADMIN_POST_SUBSCRIBE_COMMENTS)."</a></small>\n";
    $ret.="<hr></td></tr>\n";
    return $ret;
  }

  function BlogComments($post,$thread,$limit=BLOG_COMMENTS_LIMIT,$style=BLOG_CSS_STYLE,$page=0,$status=BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN,$post_user_id=false) {
    global $blog1,$userid,$username,$useremail,$bannedip;
    $ret="";
    $select="SELECT ".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_ID." AS ID, 
              DATE_FORMAT(".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_DATETIME.",'".BLOG_DATE_FORMAT."') AS Date, 
              DATE_FORMAT(".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_DATETIME.",'".BLOG_TIME_FORMAT."') AS Time,
              ".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_AUTHOR." AS User,
              ".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_CONTENT." AS Content,
              ".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_STATUS." AS Status,
              ".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_SUBSCRIBE." AS Subscribe,
              ".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_IP." AS IP,
              ".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_PARENT_ID." AS ParentID,
              ".BLOG_SPAMFILTERS_TABLE.".".BLOG_SPAMFILTERS_TABLE_ID." AS SpamID";
    $from  = "FROM ".BLOG_COMMENTS_TABLE." LEFT JOIN ".BLOG_SPAMFILTERS_TABLE." ON ".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_IP."=".BLOG_SPAMFILTERS_TABLE.".".BLOG_SPAMFILTERS_TABLE_KEYWORD." AND ".BLOG_SPAMFILTERS_TABLE.".".BLOG_SPAMFILTERS_TABLE_TYPE."='".BLOG_SPAMFILTERS_TABLE_TYPE_IP."'";
    $where = "WHERE ".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_POST_ID."='".$post."'".(! $userid?" AND ".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_STATUS."!='".BLOG_COMMENTS_TABLE_STATUS_SPAM."'":"");
    $order = " ORDER BY ".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_DATETIME;
    $sqllimit = "LIMIT ".($page?$page*$limit.",":"").$limit;
    $totalrecords=get_value("SELECT COUNT(*) ".$from." ".$where);

    while ($thread && ! get_value("SELECT COUNT(*) FROM ".BLOG_COMMENTS_TABLE." JOIN (".$select." ".$from." ".$where." ".$order." ".$sqllimit.") AS Comments2 ON Comments2.ID=".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_ID." AND Comments2.ID='".$thread."'")) {
      // Adjust a page, if thread is not found
      if ($page*$limit<$totalrecords) {
        // Try to adjust a page
        $page++;
        $sqllimit = "LIMIT ".($page?$page*$limit.",":"").$limit;
      } else {
        // Give up
        $thread=false;
        $page=0;
        $sqllimit = "LIMIT ".$limit;
        $break;
      }
    }

    $query=$select." ".$from." ".$where." ".$order." ".$sqllimit;
    $blog1->query($query);
    if ($blog1->num_rows()) {
      $arr=$out=$root=array();
      while($blog1->next_record()) {
        $arr[$blog1->f("ID")]=$blog1->Record;
      }
      foreach ($arr as $key=>$value) {
        if (isset($value["ParentID"]) && isset($arr[$value["ParentID"]])) {
          $out[$value["ParentID"]][]=$key;
        } else {
          $root[]=$key;
        }
      }
      $i=1;
      $ret.="<tr class=\"".$style."_header\"><td colspan=3 class=\"".$style."_header\">".($page?"<a class=\"".$style."_header\" href=\"".params($post, false, false, $page-1)."\">".BLOG_OLDER."</a>":"").(($page+1)*$limit<$totalrecords&&$page?" | ":"").(($page+1)*$limit<$totalrecords?"<a class=\"".$style."_header\" href=\"".params($post, false, false, $page+1)."\">".BLOG_NEWER."</a>":"").(($page+1)*$limit<$totalrecords||$page?"<br>":"")."<small class=\"".$style."\">(".($page*$limit+1)."-".($limit*($page+1)<$totalrecords?$limit*($page+1):$totalrecords)." ".BLOG_OF." ".$totalrecords.")</small></td></tr>\n";
      $ret.="<tr class=\"".$style."\"><td colspan=3 class=\"".$style."\">\n";
      foreach ($root as $key) {
        $ret.=ShowComment($post,$thread,$arr,$key,$out,$style.($i&1?"_odd":"_even"),$page,$status,($i&1?BLOG_COMMENTS_BG_COLOR_ODD:BLOG_COMMENTS_BG_COLOR_EVEN),$post_user_id);
        $i++;
      }
      $ret.="</td></tr>";
      if ($status==BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN && ! $thread && ! $bannedip) {
        $ret.="<tr class=\"".$style."\"><td colspan=3 class=\"".$style."\">".ShowCommentForm($post,$thread,$style)."</td></tr>\n";
      }
      $ret.="<tr class=\"".$style."_header\"><td colspan=3 class=\"".$style."_header\">".($page?"<a class=\"".$style."_header\" href=\"".params($post, false, false, $page-1)."\">".BLOG_OLDER."</a>":"").(($page+1)*$limit<$totalrecords&&$page?" | ":"").(($page+1)*$limit<$totalrecords?"<a class=\"".$style."_header\" href=\"".params($post, false, false, $page+1)."\">".BLOG_NEWER."</a>":"").(($page+1)*$limit<$totalrecords||$page?"<br>":"")."<small class=\"".$style."\">(".($page*$limit+1)."-".($limit*($page+1)<$totalrecords?$limit*($page+1):$totalrecords)." ".BLOG_OF." ".$totalrecords.")</small></td></tr>\n";
    } elseif ($status==BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN && ! $bannedip) {
      $ret.="<tr class=\"".$style."\"><td colspan=3 class=\"".$style."\">".ShowCommentForm($post,$thread,$style)."</td></tr>\n";
    }
    return $ret;
  }

  function ShowComment($post,$thread,$arr,$key,$out,$style=BLOG_CSS_STYLE,$page=0,$status=BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN,$color="#FFFFFF",$post_user_id=false) {
    global $userid,$username,$useremail,$userstatus,$bannedip;
    $content = preg_replace('/(\S{'.BLOG_WORD_CHARS_LIMIT.','.BLOG_WORD_CHARS_LIMIT.'})/u','$1 ',nl2br(strip_tags(stripslashes($arr[$key]["Content"]),BLOG_ALLOWED_TAGS)));
    $ret ="<div id=\"".$arr[$key]["ID"]."\" class=\"".$style."\" style=\"background-color:#".$color.($arr[$key]["Status"]==BLOG_COMMENTS_TABLE_STATUS_SPAM?"; color:".BLOG_COMMENTS_COLOR_SPAM:"; color:".BLOG_COMMENTS_COLOR)."\"><small class=\"".$style."\">".stripslashes($arr[$key]["Date"])."&nbsp;".stripslashes($arr[$key]["Time"])."</small>&nbsp;&nbsp;&nbsp;<b>".stripslashes($arr[$key]["User"])."</b>".($arr[$key]["Subscribe"]?"&nbsp;&nbsp;&nbsp;".($arr[$key]["Subscribe"]==BLOG_COMMENTS_TABLE_SUBSCRIBE_POST?BLOG_COMMENTS_SUBSCRIBED_POST:($arr[$key]["Subscribe"]==BLOG_COMMENTS_TABLE_SUBSCRIBE_REPLIES?BLOG_COMMENTS_SUBSCRIBED_REPLIES:"")):"").($status==BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN && $arr[$key]["Status"]!=BLOG_COMMENTS_TABLE_STATUS_SPAM && ! $bannedip?"&nbsp;&nbsp;&nbsp;<a class=\"".$style."\" href=\"".params($post, $arr[$key]["ID"], false, $page)."#".$arr[$key]["ID"]."\">".BLOG_COMMENTS_REPLY."</a>":"")."&nbsp;&nbsp;&nbsp;<a class=\"".$style."\" href=\"".params($post, false, false, $page)."#".$arr[$key]["ID"]."\">".BLOG_COMMENTS_THREAD."</a>".($userid && ($userid==$post_user_id || $userstatus==BLOG_USERS_TABLE_USER_STATUS_ADMIN)?"&nbsp;&nbsp;&nbsp;<a class=\"".$style."\" href=\"?table=".BLOG_COMMENTS_TABLE."&id=".$arr[$key]["ID"]."&action=".($arr[$key]["Status"]==BLOG_COMMENTS_TABLE_STATUS_SPAM?"enable":"disable")."#".$arr[$key]["ID"]."\">".($arr[$key]["Status"]==BLOG_COMMENTS_TABLE_STATUS_SPAM?BLOG_ADMIN_ENABLE:BLOG_ADMIN_DISABLE)."</a>".($arr[$key]["IP"]?"&nbsp;&nbsp;&nbsp;<a class=\"".$style."\" href=\"?table=".BLOG_COMMENTS_TABLE."&id=".$arr[$key]["ID"]."&action=".($arr[$key]["SpamID"]?"unbanip":"banip")."#".$arr[$key]["ID"]."\">".($arr[$key]["SpamID"]?BLOG_ADMIN_UNBAN_IP:BLOG_ADMIN_BAN_IP)."</a>"."&nbsp;&nbsp;&nbsp;<span class=\"".($arr[$key]["SpamID"]?"banned":"unbanned")."\">(".$arr[$key]["IP"].")</span>":""):"")."<br>".($arr[$key]["Status"]==BLOG_COMMENTS_TABLE_STATUS_SPAM?htmlspecialchars($content):$content);
    if ($status==BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN && $thread==$arr[$key]["ID"] && ! $bannedip) {
      $ret.="<div class=\"".$style."\">".ShowCommentForm($post,$thread,$style)."</div>";
    }
    if (isset($out[$arr[$key]["ID"]]) && is_array($out[$arr[$key]["ID"]])) {
      foreach ($out[$arr[$key]["ID"]] as $key) {
        $color=dechex((hexdec($color)-hexdec(BLOG_COMMENTS_BG_COLOR_DECREMENT))>hexdec(BLOG_COMMENTS_BG_COLOR_MIN)?(hexdec($color)-hexdec(BLOG_COMMENTS_BG_COLOR_DECREMENT)):BLOG_COMMENTS_BG_COLOR_MIN);
        $ret.=ShowComment($post,$thread,$arr,$key,$out,$style,$page,$status,$color,$post_user_id);
      }
    }
    $ret.="</div>\n";
    return $ret;
  }

  function ShowCommentForm($post,$thread,$style) {
    global $message,$messageok,$userid,$username,$useremail,$userstatus;
    $ret ="<div class=\"".$style."\">\n";
    $ret.="<form id=\"reply\" class=\"".$style."\" method=\"post\"><input type=\"hidden\" name=\"post\" value=\"".$post."\">".($thread?"<input type=\"hidden\" name=\"thread\" value=\"".$thread."\">":"").BLOG_COMMENT_FORM_NAME.": ".($userid?"<input type=\"hidden\" name=\"name\" value=\"".$username."\">".$username:"<input type=\"text\" name=\"name\" size=30 maxlength=255 value=\"".(isset($_POST["name"])&&$_POST["name"]?unescape($_POST["name"]):(isset($_COOKIE["name"])?unescape($_COOKIE["name"]):""))."\">")."&nbsp;&nbsp;&nbsp;".BLOG_COMMENT_FORM_EMAIL.": ".($userid?"<input type=\"hidden\" name=\"email\" value=\"".$useremail."\">".$useremail:"<input type=\"text\" name=\"email\" size=30 maxlength=255 value=\"".(isset($_POST["email"])&&$_POST["email"]?unescape($_POST["email"]):(isset($_COOKIE["email"])?unescape($_COOKIE["email"]):""))."\">")."<br>".(defined('BLOG_COMMENT_FORM_NOTICE')?"<small class=\"blog_comment_form_notice\">".BLOG_COMMENT_FORM_NOTICE."</small><br>":"").BLOG_COMMENT_FORM_BODY.":<br><textarea name=\"body\" cols=60 rows=8>".(isset($_POST["body"])&&$_POST["body"]?unescape($_POST["body"]):"")."</textarea><br>\n".BLOG_COMMENT_FORM_SUBSCRIBE.": ".get_radio("subscribe",array(BLOG_COMMENTS_TABLE_SUBSCRIBE_NO=>BLOG_COMMENTS_TABLE_SUBSCRIBE_NO_NAME,BLOG_COMMENTS_TABLE_SUBSCRIBE_REPLIES=>BLOG_COMMENTS_TABLE_SUBSCRIBE_REPLIES_NAME,BLOG_COMMENTS_TABLE_SUBSCRIBE_POST=>BLOG_COMMENTS_TABLE_SUBSCRIBE_POST_NAME),"subscribe",(isset($_COOKIE["subscribe"])?unescape($_COOKIE["subscribe"]):(isset($_POST["subscribe"])&&$_POST["subscribe"]?"1":"0")))."<br>\n";
    if (! $userid) {
      if ($code=ShowCaptcha(BLOG_CAPTCHA_FILE,BLOG_CAPTCHA_CHARSET,BLOG_CAPTCHA_LENGTH,BLOG_CAPTCHA_HEIGHT,BLOG_CAPTCHA_WIDTH,rand(0,128),rand(0,128),rand(0,128),255,255,255)) {
        $ret.="<img class=\"".$style."\" src=\"".BLOG_CAPTCHA_FILE."?".time()."\"> ".BLOG_CAPTCHA.": <input type=\"text\" name=\"code\" size=\"".BLOG_CAPTCHA_LENGTH."\" maxlength=\"".BLOG_CAPTCHA_LENGTH."\" value=\"".(isset($_POST["code"])?unescape($_POST["code"]):"")."\"> <input type=\"submit\" value=\"".BLOG_COMMENT_FORM_REGENERATE_BUTTON."\"><br>\n";
        $_SESSION["captcha"] = md5($code);
      } else {
        $ret.=BLOG_MESSAGE_CANNOT_CREATE_CAPTCHA;
      }
    }
    $ret.="<br><input type=\"submit\" name=\"action\" value=\"".BLOG_COMMENT_FORM_ADD_BUTTON."\"></form>\n";
    $ret.="</div>\n";
    if ($message) $ret.="<p class=\"message\">".$message."</p>\n";
    if ($messageok) $ret.="<p class=\"messageok\">".$messageok."</p>\n";
    return $ret;
  }

  function ShowTags($style) {
    global $blog1, $userid;
    $ret="";
    $query="SELECT ".BLOG_TAGS_TABLE_NAME.", COUNT(".BLOG_TAGS2POSTS_TABLE.".".BLOG_TAGS2POSTS_TABLE_POST_ID.") AS Counter FROM ".BLOG_TAGS_TABLE.",".BLOG_TAGS2POSTS_TABLE.",".BLOG_POSTS_TABLE." WHERE ".BLOG_TAGS_TABLE.".".BLOG_TAGS_TABLE_ID."=".BLOG_TAGS2POSTS_TABLE.".".BLOG_TAGS2POSTS_TABLE_TAG_ID." AND ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_ID."=".BLOG_TAGS2POSTS_TABLE.".".BLOG_TAGS2POSTS_TABLE_POST_ID.(! $userid?" AND ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_POST_STATUS."='".BLOG_POSTS_TABLE_POST_STATUS_PUBLIC."'":"")." GROUP BY ".BLOG_TAGS_TABLE.".".BLOG_TAGS_TABLE_ID." ORDER BY ".BLOG_TAGS_TABLE_NAME;
    $blog1->query($query);
    if ($blog1->num_rows()) {
      $ret.="\n<p class=\"".$style."\">".BLOG_TAGS.":</p>\n";
      while ($blog1->next_record()) {
        $ret.="<a class=\"".$style."\" href=\"?tag=".urlencode(stripslashes($blog1->f(BLOG_TAGS_TABLE_NAME)))."\">".stripslashes($blog1->f(BLOG_TAGS_TABLE_NAME))."</a>".(BLOG_TAGS_SHOW_COUNTERS?" (".$blog1->f("Counter").")":"")."<br>\n";
      }
    }
    return $ret;
  }

  function ShowStats($style) {
    global $blog1;
    $ret ="\n<table class=\"".$style."\"><tr class=\"".$style."\"><td class=\"".$style."\">".BLOG_STATS_HEADER.": <small class=\"".$style."\">".BLOG_STATS_HEADER_2."</small><br>";
    $ret.=BLOG_STATS_POSTS.": ".get_value("SELECT CONCAT( SUM(DATEDIFF(CreatedOn,DATE_SUB(CURDATE(),INTERVAL ".BLOG_STATS_DAYS." DAY))>=0),' / ',COUNT(*) ) FROM ".BLOG_POSTS_TABLE." WHERE ".BLOG_POSTS_TABLE_POST_STATUS."='".BLOG_POSTS_TABLE_POST_STATUS_PUBLIC."'")."<br>";
    $ret.=BLOG_STATS_COMMENTS.": ".get_value("SELECT CONCAT( SUM(DATEDIFF(CreatedOn,DATE_SUB(CURDATE(),INTERVAL ".BLOG_STATS_DAYS." DAY))>=0),' / ',COUNT(*) ) FROM ".BLOG_COMMENTS_TABLE." WHERE ".BLOG_COMMENTS_TABLE_STATUS."='".BLOG_COMMENTS_TABLE_STATUS_NORMAL."'")."<br>";
    if ($temp=get_value("SELECT CONCAT( SUM(DATEDIFF(CreatedOn,DATE_SUB(CURDATE(),INTERVAL ".BLOG_STATS_DAYS." DAY))>=0),' / ',COUNT(*) ) FROM ".BLOG_COMMENTS_TABLE." WHERE ".BLOG_COMMENTS_TABLE_STATUS."='".BLOG_COMMENTS_TABLE_STATUS_SPAM."'")) $ret.=BLOG_STATS_SPAM.": ".$temp."<br>";
    $ret.="</td></tr></table>\n";
    return $ret;
  }

  function ShowDates($style,$month=false,$year=false) {
    global $blog1;
    $ret="";
    $query="SELECT DISTINCT DATE_FORMAT(".BLOG_POSTS_TABLE_DATETIME.",'%Y') AS Year, DATE_FORMAT(".BLOG_POSTS_TABLE_DATETIME.",'%m') AS Month, DATE_FORMAT(".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_DATETIME.",'%M %Y') AS FullDate FROM ".BLOG_POSTS_TABLE." ORDER BY ".BLOG_POSTS_TABLE_DATETIME." DESC";
    $blog1->query($query);
    if ($blog1->num_rows()) {
      $ret.="\n<p class=\"".$style."\">".BLOG_ARCHIVE.":</p>\n";
      $ret.="<p class=\"".$style."\"><form class=\"".$style."\" method=\"get\"><select class=\"".$style."\" name=\"ym\" onchange=\"submit();\">\n";
      while ($blog1->next_record()) {
        $ret.="<option value=\"".$blog1->f("Year").$blog1->f("Month")."\"".(($year.$month==$blog1->f("Year").$blog1->f("Month"))?" selected":"").">".$blog1->f("FullDate")."</option>\n";
      }
      $ret.="</select></form></p>\n";
    }
    return $ret;
  }

  function ShowLoginForm($style) {
    global $userid, $username, $userstatus;
    $ret="";
    if ($userid) {
      $ret.="\n<p class=\"".$style."\">".BLOG_TOP_FORM_LOGGED."<b>".$username."</b><br>".($userstatus==BLOG_USERS_TABLE_USER_STATUS_ADMIN?" <a class=\"".$style."\" href=\"admin.php\">".BLOG_ADMIN."</a> &nbsp;":"")." <a class=\"".$style."\" href=\"./?action=profile\">".BLOG_TOP_FORM_PROFILE_BUTTON."</a> &nbsp; <a class=\"".$style."\" href=\"./?action=logout\">".BLOG_TOP_FORM_LOGOUT_BUTTON."</a></p>";
    } else {
      $ret.="<br><form class=\"".$style."\" method=\"post\"".(BLOG_LOGIN_USE_SSL?" action=\"https://".$_SERVER["SERVER_NAME"].$_SERVER["SCRIPT_NAME"]."\"":"").">\n";
      $ret.="<table class=\"".$style."\"><tr class=\"".$style."\"><th class=\"".$style."\">".BLOG_TOP_FORM_NAME.":</th><td class=\"".$style."\"><input class=\"".$style."\" name=\"username\" type=\"text\"".(isset($_POST["username"])?" value=\"".unescape($_POST["username"])."\"":"")." size=10 maxlength=40></td></tr><tr class=\"".$style."\"><th class=\"".$style."\">".BLOG_TOP_FORM_PASS.":</th><td class=\"".$style."\"><input class=\"".$style."\" name=\"password\" type=\"password\" size=10 maxlength=40></td></tr><tr class=\"".$style."\"><td colspan=2 class=\"".$style."\"><input class=\"".$style."\" name=\"action\" type=\"submit\" value=\"".BLOG_TOP_FORM_LOGIN_BUTTON."\"".(! BLOG_LOGIN_USE_SSL?" onClick=\"this.form.password.value=hex_md5(this.form.password.value);\"":"")."></td></tr></table>\n";
      $ret.="</form>\n";
    }
    return $ret;
  }

  function ShowProfileForm($style) {
    global $userid, $username, $useremail, $userljname, $userljpass;
    $ret="";
    if ($userid) {
      $ret.="<form class=\"".$style."\" method=\"post\"".(BLOG_LOGIN_USE_SSL?" action=\"https://".$_SERVER["SERVER_NAME"].$_SERVER["SCRIPT_NAME"]."\"":"").">\n";
      $ret.="<table class=\"".$style."\">";
      $ret.="<tr class=\"".$style."\"><th class=\"".$style."\">".BLOG_PROFILE_FORM_NAME.":</th><td class=\"".$style."\"><input class=\"".$style."\" name=\"name\" type=\"text\" value=\"".(isset($_POST["name"])?unescape($_POST["name"]):$username)."\" size=30 maxlength=255></td></tr>";
      $ret.="<tr class=\"".$style."\"><th class=\"".$style."\">".BLOG_PROFILE_FORM_EMAIL.":</th><td class=\"".$style."\"><input class=\"".$style."\" name=\"email\" type=\"text\" value=\"".(isset($_POST["email"])?unescape($_POST["email"]):$useremail)."\" size=30 maxlength=255></td></tr>";
      $ret.="<tr class=\"".$style."\"><th class=\"".$style."\">".BLOG_PROFILE_FORM_CURRENT_PASS.":</th><td class=\"".$style."\"><input class=\"".$style."\" name=\"password\" type=\"password\" size=10 maxlength=40></td></tr>";
      $ret.="<tr class=\"".$style."\"><th class=\"".$style."\">".BLOG_PROFILE_FORM_NEW_PASS1.":</th><td class=\"".$style."\"><input class=\"".$style."\" name=\"password1\" type=\"password\" size=10 maxlength=40></td></tr>";
      $ret.="<tr class=\"".$style."\"><th class=\"".$style."\">".BLOG_PROFILE_FORM_NEW_PASS2.":</th><td class=\"".$style."\"><input class=\"".$style."\" name=\"password2\" type=\"password\" size=10 maxlength=40></td></tr>";
      $ret.="<tr class=\"".$style."\"><th class=\"".$style."\">".BLOG_PROFILE_FORM_LJ_NAME.":</th><td class=\"".$style."\"><input class=\"".$style."\" name=\"ljname\" type=\"text\" value=\"".(isset($_POST["ljname"])?unescape($_POST["ljname"]):$userljname)."\" size=25 maxlength=255></td></tr>";
      $ret.="<tr class=\"".$style."\"><th class=\"".$style."\">".BLOG_PROFILE_FORM_LJ_PASS.":</th><td class=\"".$style."\"><input class=\"".$style."\" name=\"ljpass\" type=\"password\" value=\"".(isset($_POST["ljpass"])?unescape($_POST["ljpass"]):$userljpass)."\" size=25 maxlength=40></td></tr>";
      $ret.="<tr class=\"".$style."_button\"><td colspan=2 class=\"".$style."_button\"><input class=\"".$style."_button\" name=\"action\" type=\"submit\" value=\"".BLOG_PROFILE_FORM_UPDATE_BUTTON."\"".(! BLOG_LOGIN_USE_SSL?" onClick=\"this.form.password.value=hex_md5(this.form.password.value); if(this.form.password1.value!='') { this.form.password1.value=hex_md5(this.form.password1.value); this.form.password2.value=hex_md5(this.form.password2.value); }\"":"")."></td></tr></table>\n";
      $ret.="</form>\n";
      $ret.="\n<p class=\"".$style."\">".BLOG_PROFILE_FORM_NOTICE."</a></p>\n";
      $ret.="\n<p class=\"".$style."\">";
      $ret.=(BLOG_LJ_ENABLE_CROSSPOST&&$userljname&&$userljpass?"<a class=\"".$style."\" href=\"sync.php\">".BLOG_LJ_SYNC_TITLE."</a><br>\n":"");
      $ret.=(BLOG_LJ_ENABLE_CROSSPOST&&$userljname&&$userljpass&&function_exists('xml_parser_create')?"<a class=\"".$style."\" href=\"sync_comments.php\">".BLOG_LJ_SYNC_COMMENTS_TITLE."</a><br>\n":"");
      $ret.="</p>\n";
    }
    return $ret;
  }

  function ShowAdminForm($style,$table,$action,$id=false) {
    global $blog, $blog1, $linked, $FieldNames, $userljname, $userljpass;
    $ret ="";
    if ($id && ($action=="edit" || $action=="delete")) {
      if ($table==BLOG_POSTS_TABLE) {
        $blog1->query("SELECT ".BLOG_TAGS_TABLE_NAME." FROM ".BLOG_TAGS2POSTS_TABLE.",".BLOG_TAGS_TABLE." WHERE ".BLOG_TAGS2POSTS_TABLE.".".BLOG_TAGS2POSTS_TABLE_POST_ID."='".$id."' AND ".BLOG_TAGS2POSTS_TABLE.".".BLOG_TAGS2POSTS_TABLE_TAG_ID."=".BLOG_TAGS_TABLE.".".BLOG_TAGS_TABLE_ID." ORDER BY ".BLOG_TAGS_TABLE_NAME);
        $tags=$blog1->fill_multi_array();
      }
      $query="SELECT * FROM ".$table." WHERE ID='".$id."'";
    } else {
      $query="SELECT * FROM ".$table." LIMIT 1";
    }
    $blog1->query($query);
    $fnames=$blog1->field_names();
    $ftypes=$blog1->field_types();
    $flens=$blog1->field_lens();
    if ($blog1->num_rows() || $action=="add") {
      if ($action!="add") {
        $blog1->next_record();
      }
      $ret.="<form class=\"".$style."\" method=\"post\"".(BLOG_LOGIN_USE_SSL===true?" action=\"https://".$_SERVER["SERVER_NAME"].$_SERVER["SCRIPT_NAME"]."\"":"").">\n<table class=\"".$style."\">\n";
      $ret.="<input type=\"hidden\" name=\"table\" value=\"".$table."\">\n";
      $ret.="<input type=\"hidden\" name=\"action\" value=\"".$action."\">\n";
      $ret.="<input type=\"hidden\" name=\"id\" value=\"".$id."\">\n";
      if ($table==BLOG_POSTS_TABLE) {
        // Adding tags field into posts
        $fnames[]="Tags"; $ftypes[]="string"; $flens[]="765";
      }
      if (basename($_SERVER["SCRIPT_NAME"])=="admin.php") {
        $hiddenfields=array("ID","LJ_Post_ID","LJ_URL","Agent","PHPSession","LastAccess","IP_address","CreatedOn");
      } else {
        $hiddenfields=array("ID","Post_ID","User_ID","LJ_Post_ID","LJ_URL","Tag_ID","ParentComment_ID","Agent","CreatedOn","PHPSession","LastAccess","IP_address");
      }
      foreach ($fnames as $i=>$fname) {
        if ($action!=="add") $fvalue=stripslashes($blog1->f($fname)); else $fvalue="";
        if ($fvalue && $fname=="ID" && $style=="admin") {
          $ret.="<tr class=\"".$style."\"><td class=\"".$style."\">".(isset($FieldNames[$fname])?$FieldNames[$fname]:$fname).":</td><td class=\"".$style."\"><input class=\"".$style."\" name=\"".$fname."\" type=\"text\" size=\"".($flens[$i]<(BLOG_ADMIN_FORM_STRING_LENGTH-15)?$flens[$i]:(BLOG_ADMIN_FORM_STRING_LENGTH-15))."\" maxlength=\"".$flens[$i]."\" value=\"".(isset($_POST[$fname])?unescape($_POST[$fname]):($action!="add"?$fvalue:""))."\" readonly></td></tr>\n";
        } elseif (array_search($fname,$hiddenfields)===false) {
          if ($ftypes[$i]=="string" || $ftypes[$i]=="blob") $flens[$i]=floor($flens[$i]/3); // UTF=8 string length correction
          if ($action=="delete") { $ro=" readonly disabled"; } else { $ro=""; }
          if (strpos($fname,"ID")!==false && isset($linked[$table][$fname]) && is_array($linked[$table][$fname])) {
            list($ltable,$lcolumn,$lname,$lsubname)=$linked[$table][$fname];
            $ret.="<tr class=\"".$style."\"><td class=\"".$style."\">".($lsubname?$lsubname:(isset($FieldNames[$fname])?$FieldNames[$fname]:$fname)).":</td><td class=\"".$style."\">".get_select($style,$fname,$ltable,$lcolumn,$lname,$lsubname,$fvalue,$ro)."</td></tr>\n";
          } elseif ($flens[$i]>255) {
            $ret.="<tr class=\"".$style."\"><th colspan=2 class=\"".$style."\">".(isset($FieldNames[$fname])?$FieldNames[$fname]:$fname).":</th></tr><tr class=\"".$style."\"><td colspan=2><textarea class=\"".$style."\" name=\"".$fname."\" rows=\"".BLOG_ADMIN_FORM_TEXTAREA_ROWS."\" cols=\"".BLOG_ADMIN_FORM_TEXTAREA_COLS."\"".$ro.">".(isset($_POST[$fname])?unescape($_POST[$fname]):($action!="add"?$fvalue:""))."</textarea>";
          } elseif ($table==BLOG_POSTS_TABLE && $fname==BLOG_POSTS_TABLE_TITLE) {
            $ret.="<tr class=\"".$style."\"><th colspan=2 class=\"".$style."\">".(isset($FieldNames[$fname])?$FieldNames[$fname]:$fname).":</th></tr><tr class=\"".$style."\"><td colspan=2><input class=\"".$style."\" name=\"".$fname."\" type=\"text\" size=\"".($flens[$i]<BLOG_ADMIN_FORM_STRING_LENGTH?$flens[$i]:BLOG_ADMIN_FORM_STRING_LENGTH)."\" maxlength=\"".$flens[$i]."\" value=\"".(isset($_POST[$fname])?unescape($_POST[$fname]):($action!="add"?$fvalue:""))."\"".$ro."></td></tr>\n";
          } elseif ($table==BLOG_POSTS_TABLE && $fname==BLOG_POSTS_TABLE_POST_STATUS) {
            $ret.="<tr class=\"".$style."\"><td class=\"".$style."\">".(isset($FieldNames[$fname])?$FieldNames[$fname]:$fname).":</td><td class=\"".$style."\">".get_radio($style,array(BLOG_POSTS_TABLE_POST_STATUS_PUBLIC=>BLOG_POSTS_TABLE_POST_STATUS_PUBLIC_NAME,BLOG_POSTS_TABLE_POST_STATUS_FRIENDS=>BLOG_POSTS_TABLE_POST_STATUS_FRIENDS_NAME,BLOG_POSTS_TABLE_POST_STATUS_PRIVATE=>BLOG_POSTS_TABLE_POST_STATUS_PRIVATE_NAME),$fname,$fvalue,$ro)."</td></tr>\n";
          } elseif ($table==BLOG_POSTS_TABLE && $fname==BLOG_POSTS_TABLE_COMMENT_STATUS) {
            $ret.="<tr class=\"".$style."\"><td class=\"".$style."\">".(isset($FieldNames[$fname])?$FieldNames[$fname]:$fname).":</td><td class=\"".$style."\">".get_radio($style,array(BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN=>BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN_NAME,BLOG_POSTS_TABLE_COMMENT_STATUS_CLOSE=>BLOG_POSTS_TABLE_COMMENT_STATUS_CLOSE_NAME),$fname,$fvalue,$ro)."</td></tr>\n";
          } elseif (($table==BLOG_POSTS_TABLE || $table==BLOG_COMMENTS_TABLE) && $fname==BLOG_POSTS_TABLE_SUBSCRIBE) {
            $ret.="<tr class=\"".$style."\"><td class=\"".$style."\">".(isset($FieldNames[$fname])?$FieldNames[$fname]:$fname).":</td><td class=\"".$style."\"><input class=\"".$style."\" name=\"".$fname."\" type=\"checkbox\" value=\"1\"".(isset($_POST[$fname])&&$_POST[$fname]?" checked":($fvalue?" checked":"")).$ro."></td></tr>\n";
          } elseif ($table==BLOG_COMMENTS_TABLE && $fname==BLOG_COMMENTS_TABLE_STATUS) {
            $ret.="<tr class=\"".$style."\"><td class=\"".$style."\">".(isset($FieldNames[$fname])?$FieldNames[$fname]:$fname).":</td><td class=\"".$style."\">".get_radio($style,array(BLOG_COMMENTS_TABLE_STATUS_NORMAL=>BLOG_COMMENTS_TABLE_STATUS_NORMAL_NAME,BLOG_COMMENTS_TABLE_STATUS_SPAM=>BLOG_COMMENTS_TABLE_STATUS_SPAM_NAME),$fname,$fvalue,$ro)."</td></tr>\n";
          } elseif ($table==BLOG_USERS_TABLE && $fname==BLOG_USERS_TABLE_STATUS) {
            $ret.="<tr class=\"".$style."\"><td class=\"".$style."\">".(isset($FieldNames[$fname])?$FieldNames[$fname]:$fname).":</td><td class=\"".$style."\">".get_radio($style,array(BLOG_USERS_TABLE_USER_STATUS_LOCKED=>BLOG_USERS_TABLE_USER_STATUS_LOCKED_NAME,BLOG_USERS_TABLE_USER_STATUS_COMMENTER=>BLOG_USERS_TABLE_USER_STATUS_COMMENTER_NAME,BLOG_USERS_TABLE_USER_STATUS_REGULAR=>BLOG_USERS_TABLE_USER_STATUS_REGULAR_NAME,BLOG_USERS_TABLE_USER_STATUS_ADMIN=>BLOG_USERS_TABLE_USER_STATUS_ADMIN_NAME),$fname,$fvalue,$ro)."</td></tr>\n";
          } elseif ($table==BLOG_USERS_TABLE && $fname==BLOG_USERS_TABLE_PASS) {
            $ret.="<tr class=\"".$style."\"><td class=\"".$style."\">".(isset($FieldNames[$fname])?$FieldNames[$fname]:$fname).":</td><td class=\"".$style."\"><input class=\"".$style."\" name=\"".$fname."\" type=\"password\" size=\"".($flens[$i]<(BLOG_ADMIN_FORM_STRING_LENGTH-15)?$flens[$i]:(BLOG_ADMIN_FORM_STRING_LENGTH-15))."\" maxlength=\"".$flens[$i]."\" value=\"".(isset($_POST[$fname])?unescape($_POST[$fname]):"")."\"".$ro."></td></tr>\n";
          } elseif ($table==BLOG_SPAMFILTERS_TABLE && $fname==BLOG_SPAMFILTERS_TABLE_TYPE) {
            $ret.="<tr class=\"".$style."\"><td class=\"".$style."\">".(isset($FieldNames[$fname])?$FieldNames[$fname]:$fname).":</td><td class=\"".$style."\">".get_radio($style,array(BLOG_SPAMFILTERS_TABLE_TYPE_IP=>BLOG_SPAMFILTERS_TABLE_TYPE_IP_NAME,BLOG_SPAMFILTERS_TABLE_TYPE_BODY_KEYWORD=>BLOG_SPAMFILTERS_TABLE_TYPE_BODY_KEYWORD_NAME),$fname,$fvalue,$ro)."</td></tr>\n";
          } elseif ($fname=="Tags") {	
            if (isset($tags) && is_array($tags) && count($tags)) {
              $fvalue="";
              foreach($tags as $tag) {
                $fvalue.=($fvalue?", ":"").stripslashes($tag["Tag"]);
              }
            }
            $ret.="<tr class=\"".$style."\"><td colspan=2 class=\"".$style."\">".(isset($FieldNames[$fname])?$FieldNames[$fname]:$fname).":&nbsp;&nbsp;&nbsp;<input class=\"".$style."\" name=\"".$fname."\" type=\"text\" size=\"".($flens[$i]<(BLOG_ADMIN_FORM_STRING_LENGTH-15)?$flens[$i]:(BLOG_ADMIN_FORM_STRING_LENGTH-15))."\" maxlength=\"".$flens[$i]."\" value=\"".(isset($_POST[$fname])?unescape($_POST[$fname]):($action!="add"?$fvalue:""))."\"".$ro."></td></tr>\n";
          } else {
            $ret.="<tr class=\"".$style."\"><td class=\"".$style."\">".(isset($FieldNames[$fname])?$FieldNames[$fname]:$fname).":</td><td class=\"".$style."\"><input class=\"".$style."\" name=\"".$fname."\" type=\"text\" size=\"".($flens[$i]<(BLOG_ADMIN_FORM_STRING_LENGTH-15)?$flens[$i]:(BLOG_ADMIN_FORM_STRING_LENGTH-15))."\" maxlength=\"".$flens[$i]."\" value=\"".(isset($_POST[$fname])?unescape($_POST[$fname]):($action!="add"?$fvalue:""))."\"".$ro."></td></tr>\n";
          }
        } else {
          $ret.="<input type=\"hidden\" name=\"".(isset($FieldNames[$fname])?$FieldNames[$fname]:$fname)."\" value=\"".(isset($_POST[$fname])?unescape($_POST[$fname]):($action!="add"?$fvalue:""))."\">\n";
        }
      }
      if ($userljname && $userljpass && BLOG_LJ_ENABLE_CROSSPOST && ($action=="add" || $action=="edit")) $ret.="<tr class=\"".$style."\"><td class=\"".$style."\">".BLOG_ADMIN_LJ_ALLOW_COMMENTS.":</td><td class=\"".$style."\">".get_radio($style,array(1=>BLOG_YES,0=>BLOG_NO),"Allow_LJ_Comments",(BLOG_LJ_CLOSE_COMMENTS?0:1))."</td></tr><tr class=\"".$style."\"><td class=\"".$style."\">".BLOG_ADMIN_LJ_ADD_FOOTER.":</td><td class=\"".$style."\">".get_radio($style,array(1=>BLOG_YES,0=>BLOG_NO),"Add_LJ_footer",1)."</td></tr>\n";
      $ret.="<tr class=\"".$style."_button\"><td colspan=2 class=\"".$style."_button\"><input type=\"submit\" name=\"fakeaction\" value=\"".($action=="edit"?BLOG_ADMIN_SAVE_RECORD:($action=="delete"?BLOG_ADMIN_DELETE_RECORD:BLOG_ADMIN_ADD_RECORD))."\"".(! BLOG_LOGIN_USE_SSL && $table==BLOG_USERS_TABLE?" onClick=\"this.form.password.value=hex_md5(this.form.password.value);\"":"")."></td></tr>\n";
      $ret.="</table>\n</form>\n";
      if ($table==BLOG_POSTS_TABLE) $ret.="<p class=\"".$style."\">".BLOG_ADMIN_NOTICE."</p>\n";
    }
    return $ret;
  }

  function ShowAdminList($style,$table,$limit=BLOG_ADMIN_ROWS_LIMIT,$page=false,$orderby=false, $reverse=false) {
    global $blog,$blog1,$FieldNames;
    $ret="";
    $ret.="<p class=\"".$style."\" align=\"center\"><a href=\"?table=".$table."&action=add\">".BLOG_ADMIN_ADD."</a></p>\n";
    if (! $orderby && $table==BLOG_POSTS_TABLE) {
      $orderby=BLOG_POSTS_TABLE_DATETIME; $reverse=true;
    } elseif (! $orderby && $table==BLOG_COMMENTS_TABLE) {
      $orderby=BLOG_COMMENTS_TABLE_DATETIME; $reverse=true;
    }
    $totalrecords=get_value("SELECT COUNT(*) FROM ".$table);
    if ($table==BLOG_POSTS_TABLE) {
      $query = "SELECT ".$table.".*,".BLOG_USERS_TABLE.".".BLOG_USERS_TABLE_LOGIN." FROM ".$table." LEFT JOIN ".BLOG_USERS_TABLE." ON ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_USER_ID."=".BLOG_USERS_TABLE.".".BLOG_USERS_TABLE_ID." ORDER BY ".($orderby?$orderby:"1").($reverse?" DESC":"")." LIMIT ".($page?$page*$limit.",":"").$limit;
    } else {
      $query = "SELECT ".$table.".* FROM ".$table." ORDER BY ".($orderby?$orderby:"1").($reverse?" DESC":"")." LIMIT ".($page?$page*$limit.",":"").$limit;
    }
    $blog1->query($query);
    if ($blog1->num_rows()) {
      $fnames=$blog1->field_names();
      $ftypes=$blog1->field_types();
      $flens=$blog1->field_lens();
      $hiddenfields=array("Post_ID","User_ID","LJ_Post_ID","Tag_ID","Content","Agent","Password","PHPSession");
      $ret.="<table class=\"".$style."\">\n<tr class=\"".$style."\">\n";
      $ret.="<tr class=\"".$style."_header\"><td colspan=".(count($fnames)+1)." class=\"".$style."_header\">".(($page+1)*$limit<$totalrecords?"<a class=\"".$style."_header\" title=\"".BLOG_ADMIN_BACK_DESCRIPTION."\" href=\"".params(false, false, false, $page+1, false, false, $table, $orderby, $reverse)."\">".BLOG_ADMIN_BACK."</a>":"").(($page+1)*$limit<$totalrecords||$page?" <small class=\"".$style."\">(".($page*$limit+1)."-".($limit*($page+1)<$totalrecords?$limit*($page+1):$totalrecords)." ".BLOG_OF." ".$totalrecords.")</small> ":"").($page?"<a class=\"".$style."_header\" title=\"".BLOG_ADMIN_FORWARD_DESCRIPTION."\" href=\"".params(false, false, false, $page-1, false, false, $table, $orderby, $reverse)."\">".BLOG_ADMIN_FORWARD."</a>":"")."</td></tr>\n";
      for($i=0;$i<count($fnames);$i++) {
        $fname=$fnames[$i];
        if (array_search($fname,$hiddenfields)===false) {
          $ret.="<th class=\"".$style."\"><a class=\"".$style."\" href=\"".params(false,false,false,$page,false,false,$table,$fname,($reverse?false:true))."\">".str_replace("_"," ",isset($FieldNames[$fname])?$FieldNames[$fname]:$fname)."</a></th>";
        }
      }
      $ret.="<th class=\"".$style."\">&nbsp;</th></tr>\n";
      while ($blog1->next_record()) {
        $ret.="<tr class=\"".$style."\">\n";
        for($i=0;$i<count($fnames);$i++) {
          $fname=$fnames[$i];
          if (array_search($fname,$hiddenfields)===false) {
            if ($table==BLOG_COMMENTS_TABLE && $fname==BLOG_COMMENTS_TABLE_STATUS) {
              if ($blog1->f($fname)==BLOG_COMMENTS_TABLE_STATUS_SPAM) $fvalue=BLOG_COMMENTS_TABLE_STATUS_SPAM_NAME; else $fvalue=BLOG_COMMENTS_TABLE_STATUS_NORMAL_NAME;
            } elseif ($table==BLOG_COMMENTS_TABLE && $fname==BLOG_COMMENTS_TABLE_SUBSCRIBE) {
              if ($blog1->f($fname)==BLOG_COMMENTS_TABLE_SUBSCRIBE_POST) $fvalue=BLOG_COMMENTS_TABLE_SUBSCRIBE_POST_NAME;
              elseif ($blog1->f($fname)==BLOG_COMMENTS_TABLE_SUBSCRIBE_REPLIES) $fvalue=BLOG_COMMENTS_TABLE_SUBSCRIBE_REPLIES_NAME;
              else $fvalue=BLOG_COMMENTS_TABLE_SUBSCRIBE_NO_NAME;
            } elseif ($table==BLOG_POSTS_TABLE && $fname==BLOG_POSTS_TABLE_POST_STATUS) {
              if ($blog1->f($fname)==BLOG_POSTS_TABLE_POST_STATUS_PRIVATE) $fvalue=BLOG_POSTS_TABLE_POST_STATUS_PRIVATE_NAME; 
              elseif ($blog1->f($fname)==BLOG_POSTS_TABLE_POST_STATUS_FRIENDS) $fvalue=BLOG_POSTS_TABLE_POST_STATUS_FRIENDS_NAME; 
              else $fvalue=BLOG_POSTS_TABLE_POST_STATUS_PUBLIC_NAME;
            } elseif ($table==BLOG_POSTS_TABLE && $fname==BLOG_POSTS_TABLE_COMMENT_STATUS) {
              if ($blog1->f($fname)==BLOG_POSTS_TABLE_COMMENT_STATUS_CLOSE) $fvalue=BLOG_POSTS_TABLE_COMMENT_STATUS_CLOSE_NAME; else $fvalue=BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN_NAME;
            } elseif ($table==BLOG_POSTS_TABLE && $fname==BLOG_COMMENTS_TABLE_SUBSCRIBE) {
              if ($blog1->f($fname)==BLOG_POSTS_TABLE_SUBSCRIBE_YES) $fvalue=BLOG_YES; else $fvalue=BLOG_NO;
            } elseif ($table==BLOG_SPAMFILTERS_TABLE && $fname==BLOG_SPAMFILTERS_TABLE_TYPE) {
              if ($blog1->f($fname)==BLOG_SPAMFILTERS_TABLE_TYPE_IP) $fvalue=BLOG_SPAMFILTERS_TABLE_TYPE_IP_NAME; else $fvalue=BLOG_SPAMFILTERS_TABLE_TYPE_BODY_KEYWORD_NAME;
            } elseif ($table==BLOG_USERS_TABLE && $fname==BLOG_USERS_TABLE_STATUS) {
              if ($blog1->f($fname)==BLOG_USERS_TABLE_USER_STATUS_ADMIN) $fvalue=BLOG_USERS_TABLE_USER_STATUS_ADMIN_NAME;
              elseif ($blog1->f($fname)==BLOG_USERS_TABLE_USER_STATUS_REGULAR) $fvalue=BLOG_USERS_TABLE_USER_STATUS_REGULAR_NAME;
              elseif ($blog1->f($fname)==BLOG_USERS_TABLE_USER_STATUS_COMMENTER) $fvalue=BLOG_USERS_TABLE_USER_STATUS_COMMENTER_NAME;
              elseif ($blog1->f($fname)==BLOG_USERS_TABLE_USER_STATUS_LOCKED) $fvalue=BLOG_USERS_TABLE_USER_STATUS_LOCKED_NAME;
              else $fvalue="N/A";
            } elseif ($table==BLOG_POSTS_TABLE && ($fname==BLOG_POSTS_TABLE_TITLE || $fname==BLOG_POSTS_TABLE_ID)) {
              $fvalue="<a class=\"".$style."\" href=\"./".params($blog1->f(BLOG_POSTS_TABLE_ID))."\">".$blog1->f($fname)."</a>";
            } elseif ($table==BLOG_POSTS_TABLE && $fname==BLOG_POSTS_TABLE_LJ_URL && $blog1->f($fname)) {
              $fvalue="<a class=\"".$style."\" href=\"".stripslashes($blog1->f($fname))."\" target=_blank>".BLOG_LJ_LINK."</a>";
            } elseif ($table==BLOG_COMMENTS_TABLE && $fname==BLOG_COMMENTS_TABLE_AUTHOR) {
              $fvalue="<a class=\"".$style."\" title=\"".htmlspecialchars(nl2br(stripslashes($blog1->f(BLOG_COMMENTS_TABLE_CONTENT))))."\" href=\"./".params($blog1->f(BLOG_COMMENTS_TABLE_POST_ID),$blog1->f(BLOG_COMMENTS_TABLE_ID)."#".$blog1->f(BLOG_COMMENTS_TABLE_ID))."\">".$blog1->f($fname)."</a>";
            } else {
              $fvalue=$blog1->f($fname);
            }
            $ret.="<td class=\"".$style."\">".($fvalue?stripslashes($fvalue):"&nbsp;")."</td>\n";
          }
        }
        $ret.="<td class=\"".$style."_actions\"><a class=\"".$style."\" title=\"".BLOG_ADMIN_EDIT_DESCRIPTION."\" href=\"?table=".$table."&id=".$blog1->f("ID")."&action=edit\">".BLOG_ADMIN_EDIT."</a> <a class=\"".$style."\" title=\"".BLOG_ADMIN_DELETE_DESCRIPTION."\" href=\"?table=".$table."&id=".$blog1->f("ID")."&action=delete\">".BLOG_ADMIN_DELETE."</a></td></tr>";
      }
      $ret.="</table>";
    }
    return $ret;
  }


  function SaveTags($post_id,$tags) {
    global $blog1;
    if (count($tags)) {
      $query="DELETE FROM ".BLOG_TAGS2POSTS_TABLE." WHERE ".BLOG_TAGS2POSTS_TABLE_POST_ID."='".$post_id."'";
      $blog1->query($query);
      foreach($tags as $tag) {
        if ($tag_id=get_value("SELECT ".BLOG_TAGS_TABLE_ID." FROM ".BLOG_TAGS_TABLE." WHERE UPPER(".BLOG_TAGS_TABLE_NAME.")=UPPER('".addslashes(trim($tag))."')")) {
          // Tag exists
        } else {
          // Enter a new tag
          $query="INSERT INTO ".BLOG_TAGS_TABLE." (".BLOG_TAGS_TABLE_NAME.") VALUES (CONCAT(UPPER(SUBSTRING('".addslashes(trim($tag))."',1,1)),LOWER(SUBSTRING('".addslashes(trim($tag))."',2))))";
          $blog1->query($query);
          $tag_id=$blog1->insert_id();
        }
        $query="INSERT INTO ".BLOG_TAGS2POSTS_TABLE." (".BLOG_TAGS2POSTS_TABLE_POST_ID.",".BLOG_TAGS2POSTS_TABLE_TAG_ID.") VALUES ('".$post_id."','".$tag_id."')";
        $blog1->query($query);
      }
    }
    return true;
  }

  function GetTags($post_id) {
    global $blog1;
    $ret=array();
    $query="SELECT ".BLOG_TAGS_TABLE.".".BLOG_TAGS_TABLE_NAME." AS Name FROM ".BLOG_TAGS_TABLE.", ".BLOG_TAGS2POSTS_TABLE." WHERE ".BLOG_TAGS2POSTS_TABLE.".".BLOG_TAGS2POSTS_TABLE_POST_ID."='".$post_id."' AND ".BLOG_TAGS_TABLE.".".BLOG_TAGS_TABLE_ID."=".BLOG_TAGS2POSTS_TABLE.".".BLOG_TAGS2POSTS_TABLE_TAG_ID." ORDER BY Name";
    $blog1->query($query);
    if ($blog1->num_rows()) {
      while ($blog1->next_record()) {
        array_push($ret,stripslashes($blog1->f(0)));
      }
    }
    return $ret;
  }


  function ValidateEmail($email) {
    if (! preg_match("/^[a-z0-9.+-_]+@([a-z0-9-]+(.[a-z0-9-]+)+)$/i",$email, $matches)) {
      return false;
    }
    $domain = $matches[1];
    if (checkdnsrr($domain,'MX')) {
      // MX record found
      return true;
    } else {
      if ($domain != gethostbyname($domain)) {
        // Domain exists and resolves correctly
        return true;
      } else {
        // Domain does not exist or not resolved
        return false;
      }
    }
    // Otherwise
    return false;
  }

  function get_value($query) {
    global $blog1;
    $blog1->query($query);
    if ($blog1->num_rows()) {
      $blog1->next_record();
      return $blog1->f(0);
    } else {
      return false;
    }
  }

  function params($post=false, $thread=false, $tag=false, $page=false, $year=false, $month=false, $table=false, $orderby=false, $reverse=false) {
    $ret ="";
    $ret.=($post!==false?($ret?"&":"?")."post=".$post:"");
    $ret.=($thread!==false?($ret?"&":"?")."thread=".$thread:"");
    $ret.=($tag!==false?($ret?"&":"?")."tag=".$tag:"");
    $ret.=($page!==false?($ret?"&":"?")."page=".$page:"");
    $ret.=($year!==false?($ret?"&":"?")."year=".$year:"");
    $ret.=($month!==false?($ret?"&":"?")."month=".$month:"");
    $ret.=($table!==false?($ret?"&":"?")."table=".$table:"");
    $ret.=($orderby!==false?($ret?"&":"?")."orderby=".$orderby:"");
    $ret.=($reverse!==false?($ret?"&":"?")."reverse=1":"");
    return $ret;
  }

  // I hate this mess with magic quotes... :(
  function escape($str) {
    if (get_magic_quotes_gpc()) return $str; else return addslashes($str);
  }
  function unescape($str) {
    if (get_magic_quotes_gpc()) return stripslashes($str); else return $str;
  }


  function get_radio($style,$arr,$fname,$fvalue=false,$ro=false) {
    $ret="";
    foreach ($arr as $key=>$value) {
      $ret.="<input class=\"".$style."\" name=\"".$fname."\" type=\"radio\" value=\"".$key."\"".(isset($_POST[$fname])&&$_POST[$fname]==$key?" checked":($key==$fvalue?" checked":"")).$ro."> ".$value."&nbsp;&nbsp;&nbsp;\n";
    }
    return $ret;
  }

  function get_select($style,$fname,$ltable,$lcolumn,$lname,$lsubname=false,$fvalue=false,$ro=false) {
    global $blog;
    $ret="";
    if (! $ro) {
      $blog->query("SELECT ".$lcolumn.",".$lname.($lsubname?" AS ".$lsubname:"")." FROM ".$ltable." ORDER BY 2");
      if ($blog->num_rows()) {
        $ret.="<select name=\"".$fname."\">\n";
        while ($blog->next_record()) {
          $ret.="<option value=\"".$blog->f($lcolumn)."\"".($blog->f($lcolumn)==$fvalue?" selected":"").">".$blog->f($lsubname?$lsubname:$lname)."</option>\n";
        }
        $ret.="</select>\n";
      }
    } else {
      $blog->query("SELECT ".$lcolumn.",".$lname.($lsubname?" AS ".$lsubname:"")." FROM ".$ltable." WHERE ".$lcolumn."='".$fvalue."'");
      if ($blog->num_rows()) {
        $blog->next_record();
        $ret=$blog->f($lsubname?$lsubname:$lname);
      }
    }
    return $ret;
  }

  function ShowCaptcha($filename,$charset,$length,$height,$width,$red=0,$green=0,$blue=0,$bg_red=255,$bg_green=255,$bg_blue=255) {
    if (! is_file($filename)) {
      if (! @touch($filename)) return false;
    }
    if (is_file($filename) && is_writable($filename)) {
      $code = "";
      for($i=0; $i < $length; $i++) {
        $code = $code . substr($charset, mt_rand(0, strlen($charset) - 1), 1);
      }
      $img = @imagecreate($width, $height);
      $dstimg = @imagecreate($width, $height);
      $bgcolor = @imagecolorallocate($img, $bg_red, $bg_green, $bg_blue);
      $ncolor = @imagecolorallocate($img, $red, $green, $blue);
#      $ncolor = @imagecolorallocate($img, $red/1.1+20, $green/1.1+20, $blue/1.1+20);
      for($i=0; $i < ($width * $height) / 4; $i++) {
        @imageellipse($img, mt_rand(0,$width), mt_rand(0,$height), 1, 1, $ncolor);
      }
      $fgcolor = @imagecolorallocate($img, $red, $green, $blue);
      @imagestring($img, 5, 5, 1, $code, $fgcolor) || die("false");
      @imagecopyresized($dstimg,$img,0,0,0,0,$width,$height,$width,$height);
      @imagejpeg($dstimg,$filename) || die("false");
      @imagedestroy($img);
      @imagedestroy($dstimg);
      return $code;
    } else {
      return false;
    }
  }

  // Most prototypes of LJ functions below were written by my friend, Konstantin Strakovsky.
  // I really appreciate for his efforts !

  function LJGet($Login, $Password, $Community, $ItemID) {
    if (strlen($Password)!=32) { $Password=md5($Password); };
    $ParamsArray=array("mode"=>"getevents", "user"=>$Login, "hpassword"=>$Password, "ver"=>1, "usejournal"=>$Community, "selecttype"=>"one", "itemid"=>$ItemID, "lineendings"=>"unix", "howmany"=>1);
    return get_post('www.livejournal.com', '/interface/flat', $ParamsArray, '', 'POST');
  }

  function LJUpdate($Login, $Password, $Community, $ItemID, $Subj, $Text, $Security='public', $Tags='', $NoComments=0, $DateTime=false, $BackDated=false) {
    if (strlen($Password)!=32) { $Password=md5($Password); };
    $ParamsArray=array("mode"=>"editevent", "user"=>$Login, "hpassword"=>$Password, "ver"=>1, "usejournal"=>$Community, "selecttype"=>"one", "itemid"=>$ItemID, "lineendings"=>"unix", "security"=>$Security, "prop_taglist"=>urlencode($Tags), "prop_opt_nocomments"=>$NoComments, "subject"=>urlencode($Subj), "event"=>urlencode($Text));
    if ($DateTime) {
      // YYYY-MM-DD HH:MM:SS format
      list($date,$time)=explode(' ',$DateTime);
      list($year,$mon,$day)=explode('-',$date);
      list($hour,$min,$sec)=explode(':',$time);
      $ParamsArray=array_merge($ParamsArray, array("year"=>$year, "mon"=>$mon, "day"=>$day, "hour"=>$hour, "min"=>$min));
    }
    if ($BackDated) { $ParamsArray=array_merge($ParamsArray, array("prop_opt_backdated"=>1)); }
    if ($Security=="usemask") { $ParamsArray=array_merge($ParamsArray, array("allowmask"=>1)); }
    return get_post('www.livejournal.com', '/interface/flat', $ParamsArray, '', 'POST');
  }

  function LJAdd($Login, $Password, $Community, $Subj, $Text, $Security='public', $Tags='', $NoComments=0, $DateTime=false, $BackDated=false) {
    if (strlen($Password)!=32) { $Password=md5($Password); };
    $ParamsArray=array("mode"=>"postevent", "user"=>$Login, "hpassword"=>$Password, "ver"=>1, "usejournal"=>$Community, "lineendings"=>"unix", "security"=>$Security, "prop_taglist"=>urlencode($Tags), "prop_opt_nocomments"=>$NoComments, "subject"=>urlencode($Subj), "event"=>urlencode($Text));
    if (! $DateTime) {
      // YYYY-MM-DD HH:MM:SS format
      $DateTime=date('Y-m-d H:i:s');
    }
    list($date,$time)=explode(' ',$DateTime);
    list($year,$mon,$day)=explode('-',$date);
    list($hour,$min,$sec)=explode(':',$time);
    $ParamsArray=array_merge($ParamsArray, array("year"=>$year, "mon"=>$mon, "day"=>$day, "hour"=>$hour, "min"=>$min));
    if ($BackDated) { $ParamsArray=array_merge($ParamsArray, array("prop_opt_backdated"=>1)); }
    if ($Security=="usemask") { $ParamsArray=array_merge($ParamsArray, array("allowmask"=>1)); }
    return get_post('www.livejournal.com', '/interface/flat', $ParamsArray, '', 'POST');
  }

  function LJGetItems($Login, $Password, $Community, $SelectType, $HowMany="one", $ItemID=-1, $LastSync) {
    if (strlen($Password)!=32) { $Password=md5($Password); };
    $ParamsArray=array("mode"=>"getevents", "user"=>$Login, "hpassword"=>$Password, "ver"=>1, "usejournal"=>$Community, "lineendings"=>"unix", "selecttype"=>$SelectType, "howmany"=>$HowMany, "itemid"=>$ItemID, "lastsync"=>$LastSync);
    return get_post('www.livejournal.com', '/interface/flat', $ParamsArray, '', 'POST', 80, true);
  }

  function get_post($Host, $Page, $ParamsArray, $Referer='', $Method='GET', $Port=80, $Sync=false) {
    if (defined('DEBUG') && DEBUG) {
      print("<b>DEBUG get_post():</b> <b>host:</b>".$Host." <b>page:</b>".$Page." <b>params:</b>");
      print_r($ParamsArray);
      print("<br>\n");
    }
    $Method=strtoupper($Method);
    $Params="";
    if ($Method=="POST" || $Method=="GET") {
      foreach($ParamsArray as $key=>$param) {
        $Params.=(strlen($Params)?"&":"").$key."=".$param;
      }
    } elseif ($Method=="XML") {
      $Params="<?xml version=\"1.0\"?>\r\n".array2xml($ParamsArray);
    }
    $file=fsockopen($Host, $Port, $errno, $errstr, defined('BLOG_LJ_CONNECTION_TIMEOUT')?BLOG_LJ_CONNECTION_TIMEOUT:30);
    if ($file)  {
      $send =($Method=="GET"?"GET ":"POST ").$Page.($Method=='GET'?"?".$Params:"")." HTTP/1.0\r\n";
      if ($Referer!==false) { $send.="Referer: ".($Referer?$Referer:"http://".$Host."/")."\r\n"; }
      $send.="User-Agent: ".(defined('BLOG_LJ_USER_AGENT')?BLOG_LJ_USER_AGENT:getenv("HTTP_USER_AGENT"))."\r\n";
      $send.="Host: ".$Host."\r\n";
      $send.="Pragma: no-cache\r\n";
      $send.="Cache-Control: max-age=259200\r\n";
      if (isset($_SESSION["ljsession"]) && trim($_SESSION["ljsession"])) { $send.="Cookie: ljsession=".$_SESSION["ljsession"]."\r\n"; }
      if ($Method=='POST') {
        $send.="Content-Type: application/x-www-form-urlencoded\r\n";
        $send.="Content-Length: ".strlen($Params)."\r\n";
        $send.="\r\n".$Params;
      } elseif ($Method=='XML') {
        $send.="Content-Type: text/xml\r\n";
        $send.="Content-Length: ".strlen($Params)."\r\n";
        $send.="\r\n".$Params;
      }
      if (defined('DEBUG') && DEBUG) {
        print ("\n<br><b>=== RAW REQUEST ===</b><br>\n".nl2br($send)."\n");
      }
      fwrite($file, $send."\r\n");
      $Lines='';
      while(!feof($file)) { $Lines .= fread($file,4096); }
      fclose($file);
      # file_put_contents("/tmp/xml_data.txt","DEBUG:\n".$Lines,FILE_APPEND);
      if (defined('DEBUG') && DEBUG) {
        print ("\n<br><b>=== RAW RESPONSE ===</b><br>\n".nl2br($Lines)."\n");
      }
      if ($Method=="XML" || $Referer===false) {
        preg_match('/^(.*?)\r*\n\r*\n(.*)$/msu',$Lines,$matches);
        if (defined('DEBUG') && DEBUG) {
          print ("\n<br><b>=== HEADER ===</b><br>\n".nl2br($matches[1]));
          print ("\n<br><b>===  BODY  ===</b><br>\n".nl2br($matches[2]));
        }
        return array($matches[1],$matches[2]);
      } else {
        if ($Sync) {
          preg_match('/^(.*?)\r*\n\r*\n(.*)(^(?:success|itemid|errmsg|url|anum)\r*\n.*)$/msu',$Lines,$matches); # Good for sync
        } else {
          preg_match('/^(.*?)\r*\n\r*\n(.*?)(^(?:success|itemid|errmsg|url|anum)\r*\n.*)$/msu',$Lines,$matches); # Good for everything else
        }
        $RetValues=array();
        $arr=explode("\n", $matches[3]);
        for($i=0;$i<(count($arr)-1);$i=$i+2) {
          $RetValues[$arr[$i]]=$arr[$i+1];
        }
        if (defined('DEBUG') && DEBUG) {
          print ("\n<br><b>=== HEADER ===</b><br>\n".nl2br($matches[1]));
          print ("\n<br><b>===  BODY  ===</b><br>\n".nl2br($matches[2]));
          print ("\n<br><b>=== FOOTER ===</b><br>\n");
          print_r($RetValues);
        }
        // Return HTTP header, body and array with values, returned by LJ
        return array($matches[1],urldecode($matches[2]),$RetValues);
      }
    } else {
      die("$errno: $errstr");
    }
  }

  function array2xml($arr) {
    $ret="";
    foreach($arr as $key=>$value) {
      if (is_array($value) && is_numeric($key)) {
        $ret.=array2xml($value);
      } elseif (is_array($value) && ! is_numeric($key)) {
        $ret.="<".$key.">\r\n".array2xml($value)."</".$key.">\r\n";
      } else {
        $ret.="<".$key.">".$value."</".$key.">\r\n";
      }
    }
    return $ret;
  }

  function xml2array($contents, $get_attributes = 1, $priority = 'tag') {
    // This function was borrowed from the following link and slightly modified:
    // http://www.php.net/manual/en/function.xml-parse.php#87920
    // (C) lz_speedy@web.de - thanks to the author!
    if (!function_exists('xml_parser_create'))
    {
        return array ();
    }
    $parser = xml_parser_create('');
    xml_parser_set_option($parser, XML_OPTION_TARGET_ENCODING, "UTF-8");
    xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
    xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
    xml_parse_into_struct($parser, trim($contents), $xml_values);
    xml_parser_free($parser);
    if (!$xml_values)
        return; //Hmm...
    $xml_array = array ();
    $parents = array ();
    $opened_tags = array ();
    $arr = array ();
    $current = & $xml_array;
    $repeated_tag_index = array ();
    foreach ($xml_values as $data)
    {
        unset ($attributes, $value);
        extract($data);
        $result = array ();
        $attributes_data = array ();
        if (isset ($value))
        {
            if ($priority == 'tag')
                $result = $value;
            else
                $result['value'] = $value;
        }
        if (isset ($attributes) and $get_attributes)
        {
            foreach ($attributes as $attr => $val)
            {
                if ($priority == 'tag')
                    $attributes_data[$attr] = $val;
                else
                    $result['attr'][$attr] = $val; //Set all the attributes in a array called 'attr'
            }
        }
        if ($type == "open")
        {
            $parent[$level -1] = & $current;
            if (!is_array($current) or (!in_array($tag, array_keys($current))))
            {
                $current[$tag] = $result;
                if ($attributes_data)
                    $current[$tag . '_attr'] = $attributes_data;
                $repeated_tag_index[$tag . '_' . $level] = 1;
                $current = & $current[$tag];
            }
            else
            {
                if (isset ($current[$tag][0]))
                {
                    $current[$tag][$repeated_tag_index[$tag . '_' . $level]] = $result;
                    $repeated_tag_index[$tag . '_' . $level]++;
                }
                else
                {
                    $current[$tag] = array (
                        $current[$tag],
                        $result
                    );
                    $repeated_tag_index[$tag . '_' . $level] = 2;
                    if (isset ($current[$tag . '_attr']))
                    {
                        $current[$tag]['0_attr'] = $current[$tag . '_attr'];
                        unset ($current[$tag . '_attr']);
                    }
                }
                $last_item_index = $repeated_tag_index[$tag . '_' . $level] - 1;
                $current = & $current[$tag][$last_item_index];
            }
        }
        elseif ($type == "complete")
        {
            if (!isset ($current[$tag]))
            {
                $current[$tag] = $result;
                $repeated_tag_index[$tag . '_' . $level] = 1;
                if ($priority == 'tag' and $attributes_data)
                    $current[$tag . '_attr'] = $attributes_data;
            }
            else
            {
                if (isset ($current[$tag][0]) and is_array($current[$tag]))
                {
                    $current[$tag][$repeated_tag_index[$tag . '_' . $level]] = $result;
                    if ($priority == 'tag' and $get_attributes and $attributes_data)
                    {
                        $current[$tag][$repeated_tag_index[$tag . '_' . $level] . '_attr'] = $attributes_data;
                    }
                    $repeated_tag_index[$tag . '_' . $level]++;
                }
                else
                {
                    $current[$tag] = array (
                        $current[$tag],
                        $result
                    );
                    $repeated_tag_index[$tag . '_' . $level] = 1;
                    if ($priority == 'tag' and $get_attributes)
                    {
                        if (isset ($current[$tag . '_attr']))
                        {
                            $current[$tag]['0_attr'] = $current[$tag . '_attr'];
                            unset ($current[$tag . '_attr']);
                        }
                        if ($attributes_data)
                        {
                            $current[$tag][$repeated_tag_index[$tag . '_' . $level] . '_attr'] = $attributes_data;
                        }
                    }
                    $repeated_tag_index[$tag . '_' . $level]++; //0 and 1 index is already taken
                }
            }
        }
        elseif ($type == 'close')
        {
            $current = & $parent[$level -1];
        }
    }
    return ($xml_array);
  }

  function LJXMLLogin($Login, $Password) {
    if (! isset($_SESSION["ljsession"]) || ! trim($_SESSION["ljsession"]) ) {
      if (strlen($Password)!=32) { $Password=md5($Password); };
      $sessiongenerate=array(
        "methodCall"=>array(
          "methodName"=>"LJ.XMLRPC.sessiongenerate",
          "params"=>array(
            "param"=>array(
              "value"=>array(
                "struct"=>array(
                  0=>array(
                    "member"=>array(
                      "name"=>"username",
                      "value"=>array(
                        "string"=>$Login
                      )
                    )
                  ),
                  1=>array(
                    "member"=>array(
                      "name"=>"hpassword",
                      "value"=>array(
                        "string"=>$Password
                      )
                    )
                  ),
                  2=>array(
                    "member"=>array(
                      "name"=>"ver",
                      "value"=>array(
                        "int"=>1
                      )
                    )
                  ),
                  3=>array(
                    "member"=>array(
                      "name"=>"expiration",
                      "value"=>array(
                        "string"=>"short"
                      )
                    )
                  ),
                  4=>array(
                    "member"=>array(
                      "name"=>"ipfixed",
                      "value"=>array(
                        "string"=>"0"
                      )
                    )
                  )
                )
              )
            )
          )
        )
      );

      list($headers,$xml_data)=get_post('www.livejournal.com', '/interface/xmlrpc', $sessiongenerate, '', 'XML');
      $arr=xml2array($xml_data, 0);
      if (isset($arr["methodResponse"]["fault"])) {
        $error=$arr["methodResponse"]["fault"]["value"]["struct"]["member"][0]["value"]["string"]." (".$arr["methodResponse"]["fault"]["value"]["struct"]["member"][1]["value"]["int"].")";
        print $error;
      } else {
        if ($arr["methodResponse"]["params"]["param"]["value"]["struct"]["member"]["name"]=="ljsession") {
          $_SESSION["ljsession"]=$arr["methodResponse"]["params"]["param"]["value"]["struct"]["member"]["value"]["string"];
        }
      }
    }
    return $_SESSION["ljsession"];
  }

  function print_flush($content) {
    print $content;
    flush();
    ob_flush();
  }
?>
