<?
  // VStarBlogEngine - settings.php
  // (C) 2008-2012 Vladislav Staroselskiy (inet@vladstar.com)

  // Database access parameters
  // MAKE SURE YOU REDEFINE USERNAME AND A PASSWORD !
  define('BLOG_DATABASE_NAME','blog');
  define('BLOG_DATABASE_USER','blog');
  define('BLOG_DATABASE_PASSWORD','replace_me_with_something_else');
  define('BLOG_DATABASE_HOST','localhost');

  // Main blog title, at the top
  define('BLOG_MAIN_TITLE', 'My Blog');

  // LiveJournal settings
  define('BLOG_LJ_ENABLE_CROSSPOST',false); // enable or disable LJ crosspost feature, true/false
  define('BLOG_LJ_JOURNAL',BLOG_LJ_LOGIN); // may differ from LOGIN, if you post to the community
  define('BLOG_LJ_CONNECTION_TIMEOUT',10); // connection timeout, in seconds
  define('BLOG_LJ_CLOSE_COMMENTS',false); // default value for allowing/disallowing commens in LJ
  define('BLOG_LJ_COMMENTS',' comments in a blog'); // add this link to the end of post in LJ
  define('BLOG_LJ_LEAVE_COMMENT','Reply into a blog'); // add this link to the end of post in LJ
  define('BLOG_LJ_USER_AGENT','http://vladstar.com/blog/; blog@vladstar.com'); // user agent, presented to LJ server while synchronizing content
  define('BLOG_LJ_POSTS_TABLE','LJ_Posts'); // LJ table with cached posts
  define('BLOG_LJ_COMMENTS_TABLE','LJ_Comments'); // LJ table with cached comments
  define('BLOG_LJ_SYNC_TITLE', 'Synchronize LJ posts'); // LJ posts sync title
  define('BLOG_LJ_SYNC_COMMENTS_TITLE', 'Import LJ comments'); // LJ import comments title

  // Use SSL to submit login information. Make sure you have Javascript enabled, in case you disable it
  define('BLOG_LOGIN_USE_SSL',true);

  // Language definition, standard 2-chars definition for the HTML header
  define('BLOG_LANGUAGE','en');

  // RSS blog title
  define('BLOG_RSS_TITLE', BLOG_MAIN_TITLE);

  // Tags, allowed in comments
  define('BLOG_ALLOWED_TAGS','<b><i><u><a><img><blockquote><font>');

  // Default style prefix
  define('BLOG_CSS_STYLE','blog');

  // Date and time formats, in MySQL notation
  define('BLOG_DATE_FORMAT','%m/%d/%Y');
  define('BLOG_TIME_FORMAT','%H:%i');

  // Number of titles in preview mode, shown by default
  define('BLOG_TITLES_LIMIT', 20);

  // Number of comments, shown by default on a page
  define('BLOG_COMMENTS_LIMIT', 50);

  // Number of titles in a list (no preview), shown by default
  define('BLOG_PREVIEW_TITLES_LIMIT', 20);

  // Number of rows, shown on admin page for the table
  define('BLOG_ADMIN_ROWS_LIMIT', 50);

  // Number of comments, shown by default through RSS
  define('BLOG_RSS_ROWS_LIMIT', 20);

  // Whether to show post counters next to tags or not
  define('BLOG_TAGS_SHOW_COUNTERS', true);

  // How many max characters is allowed in a single word, befor it will be splitted
  define('BLOG_WORD_CHARS_LIMIT', 100);

  // Stats box definitions:
  define('BLOG_STATS_DAYS', 30); // How many days to show in statistics (first number)
  define('BLOG_STATS_POSTS', 'Public posts');
  define('BLOG_STATS_COMMENTS', 'Comments');
  define('BLOG_STATS_SPAM', 'Spam comments');
  define('BLOG_STATS_HEADER', '<b>Statistics</b>');
  define('BLOG_STATS_HEADER_2', '(last '.BLOG_STATS_DAYS.' days / total)');

  // Expiration time for the cookies, in seconds
  define('BLOG_COOKIE_EXPIRATION',60*60*24*30); // 30 days
  define('BLOG_SESSION_EXPIRATION',60*60*6);   // 6 hours

  // HTML body elements
  define('BLOG_TAGS','<b>Tags</b>');
  define('BLOG_ARCHIVE','<b>Archive</b>');
  define('BLOG_COMMENTS','<b>Comments</b>');
  define('BLOG_COMMENTS_REPLY','reply');
  define('BLOG_COMMENTS_THREAD','thread');
  define('BLOG_COMMENTS_SUBSCRIBED_REPLIES','<small title="subscribed for replies">(R)</small>');
  define('BLOG_COMMENTS_SUBSCRIBED_POST','<small title="subscribed for all comments">(A)</small>');
  define('BLOG_POST_REPLY','click here to reply');
  define('BLOG_POST_COMMENT','add new comment');
  define('BLOG_NONE','none');
  define('BLOG_POSTED_BY','Posted by');
  define('BLOG_BY_TAG','Tag:');
  define('BLOG_BY_DATE','Archive for ');
  define('BLOG_OLDER','<img src="images/left.gif">');
  define('BLOG_OLDER_DESCRIPTION','Older entries');
  define('BLOG_NEWER','<img src="images/right.gif">');
  define('BLOG_NEWER_DESCRIPTION','Newer entries');
  define('BLOG_OF','of');
  define('BLOG_MORE','...read full post ');
  define('BLOG_NO','No');
  define('BLOG_YES','Yes');
  define('BLOG_LJ','<b>LJ</b>');
  define('BLOG_LJ_LINK','link');
  define('BLOG_LJ_ERROR','LJ reported:');

  // Comment form parameters
  define('BLOG_COMMENT_FORM_NAME','<b>Name</b>');
  define('BLOG_COMMENT_FORM_EMAIL','<b>E-mail</b>');
  define('BLOG_COMMENT_FORM_SUBSCRIBE','<b>Subscribe</b>');
  define('BLOG_COMMENT_FORM_BODY','<b>Message</b>');
  define('BLOG_COMMENT_FORM_NOTICE','Your e-mail is required, but never shown to public, allowed tags: '.htmlspecialchars(BLOG_ALLOWED_TAGS));
  define('BLOG_COMMENT_FORM_ADD_BUTTON','Add comment');
  define('BLOG_COMMENT_FORM_REGENERATE_BUTTON','Regenerate');

  define('BLOG_TOP_FORM_NAME','<b>Username</b>');
  define('BLOG_TOP_FORM_PASS','<b>Password</b>');
  define('BLOG_TOP_FORM_LOGIN_BUTTON','Login');
  define('BLOG_TOP_FORM_LOGOUT_BUTTON','Logout');
  define('BLOG_TOP_FORM_PROFILE_BUTTON','Profile');
  define('BLOG_TOP_FORM_LOGGED','You are logged in as ');

  define('BLOG_PROFILE_FORM_TITLE','Update your profile');
  define('BLOG_PROFILE_FORM_NAME','Full name');
  define('BLOG_PROFILE_FORM_EMAIL','E-Mail');
  define('BLOG_PROFILE_FORM_CURRENT_PASS','Current password');
  define('BLOG_PROFILE_FORM_NEW_PASS1','New password');
  define('BLOG_PROFILE_FORM_NEW_PASS2','Repeat new password');
  define('BLOG_PROFILE_FORM_LJ_NAME','LiveJournal username');
  define('BLOG_PROFILE_FORM_LJ_PASS','LiveJournal password (can be MD5-encrypted)');
  define('BLOG_PROFILE_FORM_UPDATE_BUTTON','Update profile');
  define('BLOG_PROFILE_FORM_NOTICE','You have to enter a current password in order to make changes in your profile.<br> Enter a new password twice, only in case you want to change it.');

  // Control form parameters, you may neet adjust them, depending on the width of your page
  define('BLOG_ADMIN_FORM_STRING_LENGTH',106);
  define('BLOG_ADMIN_FORM_TEXTAREA_ROWS',15);
  define('BLOG_ADMIN_FORM_TEXTAREA_COLS',75);

  // Various control string definitions, feel free to change them as needed
  define('BLOG_ADMIN','Admin');
  define('BLOG_ADMIN_TITLE','Blog admin interface');
  define('BLOG_ADMIN_POST_ADD','Add new post');
  define('BLOG_ADMIN_POST_EDIT','Edit post');
  define('BLOG_ADMIN_POST_DELETE','Delete post');
  define('BLOG_ADMIN_POST_SAVE','Save post');
  define('BLOG_ADMIN_POST_CLOSE_COMMENTS','Close comments');
  define('BLOG_ADMIN_POST_OPEN_COMMENTS','Open comments');
  define('BLOG_ADMIN_POST_SUBSCRIBE_COMMENTS','Subscribe');
  define('BLOG_ADMIN_POST_UNSUBSCRIBE_COMMENTS','Unsubscribe');
  define('BLOG_ADMIN_ENABLE','unspam');
  define('BLOG_ADMIN_DISABLE','spam');
  define('BLOG_ADMIN_BAN_IP','ban ip');
  define('BLOG_ADMIN_UNBAN_IP','unban ip');
  define('BLOG_ADMIN_KILL_SPAM','Kill all spam comments');
  define('BLOG_ADMIN_DELETE_UNUSED_TAGS','Delete all unused tags');
  define('BLOG_ADMIN_NOTICE','Tags must be comma-separated. You can also use <b>&lt;!--more--&gt;</b> in a post to separate preview from the full text.');
  define('BLOG_ADMIN_BACK','<img src="images/left.gif">');
  define('BLOG_ADMIN_BACK_DESCRIPTION','Back');
  define('BLOG_ADMIN_FORWARD','<img src="images/right.gif">');
  define('BLOG_ADMIN_FORWARD_DESCRIPTION','Forward');
  define('BLOG_ADMIN_ADD','Add new record');
  define('BLOG_ADMIN_EDIT','<img src="images/edit.gif">');
  define('BLOG_ADMIN_EDIT_DESCRIPTION','Edit record');
  define('BLOG_ADMIN_DELETE','<img src="images/delete.gif">');
  define('BLOG_ADMIN_DELETE_DESCRIPTION','Delete record');
  define('BLOG_ADMIN_ADD_RECORD','Add record');
  define('BLOG_ADMIN_EDIT_RECORD','Edit record');
  define('BLOG_ADMIN_DELETE_RECORD','Delete record');
  define('BLOG_ADMIN_SAVE_RECORD','Update record');
  define('BLOG_ADMIN_ACTIONS','Actions');
  define('BLOG_ADMIN_TABLE_MANAGEMENT','Table Management');
  define('BLOG_ADMIN_LJ_ALLOW_COMMENTS','Allow LJ comments');
  define('BLOG_ADMIN_LJ_ADD_FOOTER','Add reply link to LJ post');


  define('BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN_NAME','Open');
  define('BLOG_POSTS_TABLE_COMMENT_STATUS_CLOSE_NAME','Close');
  define('BLOG_POSTS_TABLE_POST_STATUS_PUBLIC_NAME','Public');
  define('BLOG_POSTS_TABLE_POST_STATUS_FRIENDS_NAME','Friends Only');
  define('BLOG_POSTS_TABLE_POST_STATUS_FRIENDS_SIGN','<img src="images/friends.gif">');
  define('BLOG_POSTS_TABLE_POST_STATUS_PRIVATE_NAME','Private');
  define('BLOG_POSTS_TABLE_POST_STATUS_PRIVATE_SIGN','<img src="images/private.gif">');
  define('BLOG_SPAMFILTERS_TABLE_TYPE_IP_NAME','IP address');
  define('BLOG_SPAMFILTERS_TABLE_TYPE_BODY_KEYWORD_NAME','Keyword');
  define('BLOG_COMMENTS_TABLE_STATUS_NORMAL_NAME','Not spam');
  define('BLOG_COMMENTS_TABLE_STATUS_SPAM_NAME','Spam');
  define('BLOG_COMMENTS_TABLE_SUBSCRIBE_NO_NAME','No');
  define('BLOG_COMMENTS_TABLE_SUBSCRIBE_REPLIES_NAME','Replies only');
  define('BLOG_COMMENTS_TABLE_SUBSCRIBE_POST_NAME','All comments');
  define('BLOG_USERS_TABLE_USER_STATUS_LOCKED_NAME','Disabled');
  define('BLOG_USERS_TABLE_USER_STATUS_COMMENTER_NAME','Commenter');
  define('BLOG_USERS_TABLE_USER_STATUS_REGULAR_NAME','Writer');
  define('BLOG_USERS_TABLE_USER_STATUS_ADMIN_NAME','Admin');

  // Comment parameters to make color gradient in a tree
  define('BLOG_COMMENTS_BG_COLOR_ODD', 'F0F8F0');
  define('BLOG_COMMENTS_BG_COLOR_EVEN', 'F0FFFF');
  define('BLOG_COMMENTS_BG_COLOR_DECREMENT', '020202');
  define('BLOG_COMMENTS_BG_COLOR_MIN', '808080');
  define('BLOG_COMMENTS_COLOR_SPAM', 'CCCCCC');
  define('BLOG_COMMENTS_COLOR', '000000');

  // Captcha parameters:
  define('BLOG_CAPTCHA','Please, enter the code you see on a picture');
  define('BLOG_CAPTCHA_FILE','captcha.jpg');
  define('BLOG_CAPTCHA_CHARSET','0123456789');
  define('BLOG_CAPTCHA_LENGTH',6);
  define('BLOG_CAPTCHA_HEIGHT',20);
  define('BLOG_CAPTCHA_WIDTH',60);

  // Various messages
  define('BLOG_MESSAGE_POST_NOT_FOUND','Sorry, requested post is not found');
  define('BLOG_MESSAGE_POST_NO_TITLE','Sorry, you forgot to enter a title');
  define('BLOG_MESSAGE_POST_NO_CONTENT','Sorry, forgot to enter a post content');
  define('BLOG_MESSAGE_POST_NO_TAGS','Sorry, you forgot to enter tags');
  define('BLOG_MESSAGE_CANNOT_CREATE_CAPTCHA','<i>Cannot create a captcha file ('.BLOG_CAPTCHA_FILE.'), or it exists, but not writable for the server</i>');
  define('BLOG_MESSAGE_NO_NAME','Sorry, you have to enter your name');
  define('BLOG_MESSAGE_INVALID_EMAIL','Sorry, you forgot to enter an e-mail or your e-mail address is invalid');
  define('BLOG_MESSAGE_INVALID_PASS','Sorry, you forgot to enter a current password');
  define('BLOG_MESSAGE_PASSES_DONT_MATCH','Sorry, your new passwords don\'t match - please, re-enter');
  define('BLOG_MESSAGE_NO_MESSAGE','Sorry, you cannot reply with an empty message');
  define('BLOG_MESSAGE_WRONG_CAPTCHA','Sorry, specified code is wrong');
  define('BLOG_MESSAGE_POST_NOT_ALLOWED','Sorry, this post does not exist or now closed for commenting');
  define('BLOG_MESSAGE_COMMENT_ADDED','Your comment has been added to this post');
  define('BLOG_MESSAGE_DUPLICATE_COMMENT','Sorry, it seems you already posted this comment');
  define('BLOG_MESSAGE_BANNED_IP','Sorry, your IP address has been banned from posting here.');
  define('BLOG_MESSAGE_BANNED_KEYWORDS','Sorry, your message contains some banned keywords, please, rewrite it.');
  define('BLOG_MESSAGE_INCORRECT_LOGIN','Sorry, your login information is incorrect');
  define('BLOG_MESSAGE_LOCKED_ACCOUNT','Sorry, your account is locked');
  define('BLOG_MESSAGE_ACCESS_DENIED','Sorry, access denied');
  define('BLOG_MESSAGE_UNSUBSCRIBE','You have been successfully unsubscribed.');

  define('BLOG_MESSAGE_ADMIN_NO_TABLE','Sorry, such table does not exist');
  define('BLOG_MESSAGE_LJ_CROSSPOST_DISABLED','Sorry, it seems LJ crosspost is disabled'); // Disabled LJ crosspost message

  // Mail defiinitions
  define('BLOG_MAIL_ENABLE_NOTIFICATIONS',true); // enable or disable e-mail notifications, true/false
  define('BLOG_MAIL_NOTIFICATION_FROM',$_SERVER["SERVER_NAME"].' blog'.' <nobody@'.$_SERVER["SERVER_NAME"].'>');
  define('BLOG_MAIL_NOTIFICATION_SUBJECT','A new comment is being posted to '.$_SERVER["SERVER_NAME"].' blog');
  define('BLOG_MAIL_NOTIFICATION_HEAD',"");
  define('BLOG_MAIL_NOTIFICATION_TAIL',"Please, do not reply on this e-mail, post your comment through the web instead.");
  define('BLOG_MAIL_NOTIFICATION_UNSUBSCRIBE',"You can also unsubscribe from this topic by clicking on the following link:");
  define('BLOG_MAIL_NOTIFICATION_IN_CHARSET','utf-8');
  define('BLOG_MAIL_NOTIFICATION_OUT_CHARSET','windows-1251');
  define('BLOG_MAIL_NOTIFICATION_HEADERS','Content-type: text/plain; charset='.BLOG_MAIL_NOTIFICATION_OUT_CHARSET."\n"."From: ".BLOG_MAIL_NOTIFICATION_FROM."\n");
  define('BLOG_MAIL_NOTIFICATION_WROTE'," wrote");
  define('BLOG_MAIL_NOTIFICATION_REPLYTO'," replied to ");

  define('BLOG_LJ_SYNC_ACTION_START','Start');
  define('BLOG_LJ_SYNC_ACTION_NEXT','Next');
  define('BLOG_LJ_SYNC_ACTION_FINISH','Finish');
  define('BLOG_LJ_SYNC_ACTION_SYNC','Add blog items to LJ');
  define('BLOG_LJ_SYNC_ACTION_CANCEL','Cancel');
  define('BLOG_LJ_SYNC_ACTION_ADD_TO_BLOG','Add to blog');
  define('BLOG_LJ_SYNC_ACTION_DELETE_FROM_LJ','Delete from LJ');
  define('BLOG_LJ_SYNC_ACTION_UPDATE_BLOG','Update blog');
  define('BLOG_LJ_SYNC_ACTION_UPDATE_LJ','Update LJ');
  define('BLOG_LJ_SYNC_ACTION_NONE','None');
  define('BLOG_LJ_SYNC_DIFF_TITLE','title');
  define('BLOG_LJ_SYNC_DIFF_POST_STATUS','status');
  define('BLOG_LJ_SYNC_DIFF_LJ_ID','LJ ID');
  define('BLOG_LJ_SYNC_DIFF_LJ_URL','LJ URL');
  define('BLOG_LJ_SYNC_DIFF_CONTENT','content');
  define('BLOG_LJ_SYNC_DIFF_MISSING','no record');
  define('BLOG_LJ_SYNC_PROCESS_DONE','<p>All done, blog posts were synchronized. Please, <a href="sync_comments.php">click here</a> to import comments from LJ or <a href="admin.php">click here</a> to return to admin interface.</p>');
  define('BLOG_LJ_SYNC_PROCESSING_1','Processing');
  define('BLOG_LJ_SYNC_PROCESSING_2','item(s), please, wait');
  define('BLOG_LJ_SYNC_BLOG2LJ_NOTICE','<p>There are some posts, that appear in a blog, but don\'t appear in LJ. Do you want to add them to LJ now ?</p>');
  define('BLOG_LJ_SYNC_BLOG2LJ_ADD','Adding blog record #');
  define('BLOG_LJ_SYNC_BLOG2LJ_NEW_LJ_RECORD','new record is being added to LJ as item #');
  define('BLOG_LJ_SYNC_BLOG2LJ_FAILED','failed');
  define('BLOG_LJ_SYNC_START_NOTICE','Choose a type of synchronization - all records or new records only, then press <b>'.BLOG_LJ_SYNC_ACTION_START.'</b> button to begin.');
  define('BLOG_LJ_SYNC_START_COMPLETE','All records');
  define('BLOG_LJ_SYNC_START_CONTINUE','New records only');
  define('BLOG_LJ_SYNC_NO_NEW_RECORDS','Sorry, no new records were found.');
  define('BLOG_LJ_SYNC_FETCHING_DATA','Fetching data from LiveJournal... ');
  define('BLOG_LJ_SYNC_PARSING_DATA','Parsing data... ');
  define('BLOG_LJ_SYNC_MATCHING_DATA','Matching data to existing blog records... ');
  define('BLOG_LJ_SYNC_RESULTS','see resulting table below');
  define('BLOG_LJ_SYNC_FOUND', 'found');
  define('BLOG_LJ_SYNC_RECORDS', 'records');
  define('BLOG_LJ_SYNC_DONE', 'done');

  define('BLOG_LJ_SYNC_COMMENTS_IMPORT_WAIT', 'Importing comments, please wait... ');
  define('BLOG_LJ_SYNC_COMMENTS_BUILD_TREE_WAIT', 'Building a comments tree, please wait... ');
  define('BLOG_LJ_SYNC_COMMENTS_DONE', 'done');
  define('BLOG_LJ_SYNC_COMMENTS_TOP_NOTICE', '<p><small>Depending on number of LJ comments you have, your browser may time out. Simply hit Refresh or <a href="sync_comments.php">click here</a> if you feel, that process got stuck. It will resume from the moment when it stopped working.</small></p>');
  define('BLOG_LJ_SYNC_COMMENTS_DL_METADATA_AND_USERMAPS', '<b>Downloading metadata and usermaps:</b>');
  define('BLOG_LJ_SYNC_COMMENTS_RECORDS_ADDED_TO_CACHE', 'new records were added to cache');
  define('BLOG_LJ_SYNC_COMMENTS_DL_COMMENTS', '<b>Downloading comments</b>');
  define('BLOG_LJ_SYNC_COMMENTS_NO_NEW_COMMENTS', 'There are no new comments found.');
  define('BLOG_LJ_SYNC_COMMENTS_NEW_COMMENTS_1', 'There are');
  define('BLOG_LJ_SYNC_COMMENTS_NEW_COMMENTS_2', 'new comments to add to your blog. Do you want to proceed with it ?');
  define('BLOG_LJ_SYNC_COMMENTS_PARSING', 'Parsing');
  define('BLOG_LJ_SYNC_COMMENTS_RECORDS', 'records');
  define('BLOG_LJ_SYNC_COMMENTS_MAX_ATTEMPTS', 50);
  define('BLOG_LJ_SYNC_COMMENTS_LOAD','Load attempt');
  define('BLOG_LJ_SYNC_COMMENTS_STARTID','fetching records, starting from');

  // This is to substitute field names, while adding/editing or deleting records
  $FieldNames=array(
    'CreatedOn'=>'Created On',
    'LastAccess'=>'Last access',
    'Title'=>'Title',
    'Content'=>'Content',
    'PostStatus'=>'Post status',
    'CommentsStatus'=>'Comment status',
    'Subscribe'=>'Subscribe',
    'Tags'=>'Tags',
    'Username'=>'Username',
    'Password'=>'Password',
    'Parent_ID'=>'Reply to',
    'Author'=>'Author',
    'Status'=>'Status',
    'IP_address'=>'IP-address',
    'Keyword'=>'Keyword',
    'Type'=>'Type',
    'Tag'=>'Tag',
    'Fullname'=>'Full name',
    'LJ_ID'=>'LJ ID',
    'Post_ID'=>'Post #',
    'Difference'=>'Difference',
    'Action'=>'Action',
    'Add'=>'Add'
  );

  // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! //
  // Don't touch definitions below, unless you really know what you are doing //
  // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! //

  // Table names
  define('BLOG_USERS_TABLE','Users');
  define('BLOG_POSTS_TABLE','Posts');
  define('BLOG_COMMENTS_TABLE','Comments');
  define('BLOG_TAGS_TABLE','Tags');
  define('BLOG_TAGS2POSTS_TABLE','Tags2Posts');
  define('BLOG_SPAMFILTERS_TABLE','SpamFilters');

  // Database fields (columns)
  define('BLOG_USERS_TABLE_ID','ID');
  define('BLOG_USERS_TABLE_NAME','Fullname');
  define('BLOG_USERS_TABLE_LOGIN','Username');
  define('BLOG_USERS_TABLE_EMAIL','EMail');
  define('BLOG_USERS_TABLE_PASS','Password');
  define('BLOG_USERS_TABLE_STATUS','Status');
  define('BLOG_USERS_TABLE_SESSION','PHPSession');
  define('BLOG_USERS_TABLE_LAST_ACCESS','LastAccess');
  define('BLOG_USERS_TABLE_LJ_NAME','LJ_username');
  define('BLOG_USERS_TABLE_LJ_PASS','LJ_password');

  define('BLOG_POSTS_TABLE_ID','ID');
  define('BLOG_POSTS_TABLE_USER_ID','User_ID');
  define('BLOG_POSTS_TABLE_DATETIME','CreatedOn');
  define('BLOG_POSTS_TABLE_TITLE','Title');
  define('BLOG_POSTS_TABLE_CONTENT','Content');
  define('BLOG_POSTS_TABLE_POST_STATUS','PostStatus');
  define('BLOG_POSTS_TABLE_COMMENT_STATUS','CommentsStatus');
  define('BLOG_POSTS_TABLE_SUBSCRIBE','Subscribe');
  define('BLOG_POSTS_TABLE_LJ','LJ_Post_ID');
  define('BLOG_POSTS_TABLE_LJ_URL','LJ_URL');

  define('BLOG_COMMENTS_TABLE_ID','ID');
  define('BLOG_COMMENTS_TABLE_POST_ID','Post_ID');
  define('BLOG_COMMENTS_TABLE_PARENT_ID','Parent_ID');
  define('BLOG_COMMENTS_TABLE_DATETIME','CreatedOn');
  define('BLOG_COMMENTS_TABLE_AUTHOR','Author');
  define('BLOG_COMMENTS_TABLE_EMAIL','EMail');
  define('BLOG_COMMENTS_TABLE_CONTENT','Content');
  define('BLOG_COMMENTS_TABLE_STATUS','Status');
  define('BLOG_COMMENTS_TABLE_SUBSCRIBE','Subscribe');
  define('BLOG_COMMENTS_TABLE_IP','IP_address');
  define('BLOG_COMMENTS_TABLE_AGENT','Agent');

  define('BLOG_TAGS_TABLE_ID','ID');
  define('BLOG_TAGS_TABLE_NAME','Tag');

  define('BLOG_TAGS2POSTS_TABLE_POST_ID','Post_ID');
  define('BLOG_TAGS2POSTS_TABLE_TAG_ID','Tag_ID');

  define('BLOG_SPAMFILTERS_TABLE_ID','ID');
  define('BLOG_SPAMFILTERS_TABLE_TYPE','Type');
  define('BLOG_SPAMFILTERS_TABLE_KEYWORD','Keyword');

  // LJ Sync database structure
  define('BLOG_LJ_SYNC_POSTS_TABLE','LJ_Posts');
  define('BLOG_LJ_SYNC_POSTS_TABLE_ID','lj_post_id');
  define('BLOG_LJ_SYNC_POSTS_TABLE_POST_ID','blog_post_id');
  define('BLOG_LJ_SYNC_POSTS_TABLE_DATETIME','eventtime');
  define('BLOG_LJ_SYNC_POSTS_TABLE_TITLE','subject');
  define('BLOG_LJ_SYNC_POSTS_TABLE_CONTENT','event');
  define('BLOG_LJ_SYNC_POSTS_TABLE_TAGS','taglist');
  define('BLOG_LJ_SYNC_POSTS_TABLE_SECURITY','security');
  define('BLOG_LJ_SYNC_POSTS_TABLE_URL','url');
  define('BLOG_LJ_SYNC_POSTS_TABLE_ACTION','action');

  // LJ Comments database structure
  define('BLOG_LJ_SYNC_COMMENTS_TABLE','LJ_Comments');
  define('BLOG_LJ_SYNC_COMMENTS_TABLE_ID','id');
  define('BLOG_LJ_SYNC_COMMENTS_TABLE_POSTERID','posterid');
  define('BLOG_LJ_SYNC_COMMENTS_TABLE_STATE','state');
  define('BLOG_LJ_SYNC_COMMENTS_TABLE_JITEMID','jitemid');
  define('BLOG_LJ_SYNC_COMMENTS_TABLE_PARENTID','parentid');
  define('BLOG_LJ_SYNC_COMMENTS_TABLE_SUBJECT','subject');
  define('BLOG_LJ_SYNC_COMMENTS_TABLE_BODY','body');
  define('BLOG_LJ_SYNC_COMMENTS_TABLE_DATE','date');

  // LJ Comments metadata database structure
  define('BLOG_LJ_SYNC_COMMENTS_METADATA_TABLE','LJ_Comments_metadata');
  define('BLOG_LJ_SYNC_COMMENTS_METADATA_TABLE_ID','id');
  define('BLOG_LJ_SYNC_COMMENTS_METADATA_TABLE_POSTERID','posterid');
  define('BLOG_LJ_SYNC_COMMENTS_METADATA_TABLE_STATE','state');

  // LJ Comments usermaps database structure
  define('BLOG_LJ_SYNC_COMMENTS_USERMAPS_TABLE','LJ_Comments_usermaps');
  define('BLOG_LJ_SYNC_COMMENTS_USERMAPS_TABLE_ID','id');
  define('BLOG_LJ_SYNC_COMMENTS_USERMAPS_TABLE_USER','user');

  define('BLOG_LJ_SYNC_SECURITY_FRIENDSONLY','usemask'); // Friends Only
  define('BLOG_LJ_SYNC_SECURITY_PRIVATE','private'); // Private

  // Sleep interval between LJ requests, in microseconds. Should be 200K+, according to their bot policy
  define('BLOG_LJ_SYNC_SLEEP','200000'); 

  // Definitions for various some field values

  define('BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN','0');
  define('BLOG_POSTS_TABLE_COMMENT_STATUS_CLOSE','1');
  define('BLOG_POSTS_TABLE_POST_STATUS_PUBLIC','0');
  define('BLOG_POSTS_TABLE_POST_STATUS_FRIENDS','1');
  define('BLOG_POSTS_TABLE_POST_STATUS_PRIVATE','2');
  define('BLOG_POSTS_TABLE_SUBSCRIBE_NO','0');
  define('BLOG_POSTS_TABLE_SUBSCRIBE_YES','1');
  define('BLOG_COMMENTS_TABLE_SUBSCRIBE_NO','0');
  define('BLOG_COMMENTS_TABLE_SUBSCRIBE_REPLIES','1');
  define('BLOG_COMMENTS_TABLE_SUBSCRIBE_POST','2');
  define('BLOG_COMMENTS_TABLE_STATUS_NORMAL','0');
  define('BLOG_COMMENTS_TABLE_STATUS_SPAM','1');
  define('BLOG_USERS_TABLE_USER_STATUS_LOCKED','0');
  define('BLOG_USERS_TABLE_USER_STATUS_COMMENTER','1');
  define('BLOG_USERS_TABLE_USER_STATUS_REGULAR','2');
  define('BLOG_USERS_TABLE_USER_STATUS_ADMIN','9');
  define('BLOG_SPAMFILTERS_TABLE_TYPE_IP','1');
  define('BLOG_SPAMFILTERS_TABLE_TYPE_BODY_KEYWORD','2');

  // You may need to adjust this, in case you have memory or timeout problems
  ini_set("memory_limit","60M");
  ini_set("max_execution_time","180");
?>
